var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
System.register("components/getDisplayName", [], function (exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [],
        execute: function () {
            exports_1("default", (hocName, WrappedComponent) => `${hocName}(${WrappedComponent.displayName ||
                WrappedComponent.name ||
                'Component'})`);
        }
    };
});
System.register("components/AuthorizationProvider", ["react", "components/getDisplayName"], function (exports_2, context_2) {
    "use strict";
    var react_1, getDisplayName_1, _a, Consumer, Provider, AuthorizationProvider, withAuthorization;
    var __moduleName = context_2 && context_2.id;
    return {
        setters: [
            function (react_1_1) {
                react_1 = react_1_1;
            },
            function (getDisplayName_1_1) {
                getDisplayName_1 = getDisplayName_1_1;
            }
        ],
        execute: function () {
            _a = react_1.default.createContext(undefined), Consumer = _a.Consumer, Provider = _a.Provider;
            AuthorizationProvider = ({ authorization, children }) => (react_1.default.createElement(Provider, { value: authorization }, children));
            exports_2("default", AuthorizationProvider);
            withAuthorization = () => (WrappedComponent) => {
                const Component = (props) => (react_1.default.createElement(Consumer, null, authorization => (react_1.default.createElement(WrappedComponent, Object.assign({}, props, { authorization: authorization })))));
                Component.displayName = getDisplayName_1.default('WithAuthorization', WrappedComponent);
                return Component;
            };
            exports_2("withAuthorization", withAuthorization);
        }
    };
});
System.register("components/NavigationProvider", ["react", "components/getDisplayName"], function (exports_3, context_3) {
    "use strict";
    var react_2, getDisplayName_2, defaultNavigationHandler, _a, Consumer, Provider, NavigationProvider, withNavigation;
    var __moduleName = context_3 && context_3.id;
    return {
        setters: [
            function (react_2_1) {
                react_2 = react_2_1;
            },
            function (getDisplayName_2_1) {
                getDisplayName_2 = getDisplayName_2_1;
            }
        ],
        execute: function () {
            defaultNavigationHandler = (link, authorization) => {
                return;
            };
            _a = react_2.default.createContext(defaultNavigationHandler), Consumer = _a.Consumer, Provider = _a.Provider;
            NavigationProvider = ({ onNavigate, children }) => (react_2.default.createElement(Provider, { value: onNavigate }, children));
            exports_3("default", NavigationProvider);
            withNavigation = () => (WrappedComponent) => {
                const Component = (props) => (react_2.default.createElement(Consumer, null, onNavigate => (react_2.default.createElement(WrappedComponent, Object.assign({}, props, { onNavigate: onNavigate })))));
                Component.displayName = getDisplayName_2.default('WithNavigation', WrappedComponent);
                return Component;
            };
            exports_3("withNavigation", withNavigation);
        }
    };
});
System.register("utils/history", ["history", "uri-js"], function (exports_4, context_4) {
    "use strict";
    var history_1, uri_js_1, history, getPathAndQuery, push;
    var __moduleName = context_4 && context_4.id;
    return {
        setters: [
            function (history_1_1) {
                history_1 = history_1_1;
            },
            function (uri_js_1_1) {
                uri_js_1 = uri_js_1_1;
            }
        ],
        execute: function () {
            history = history_1.createBrowserHistory();
            getPathAndQuery = (url) => {
                const { path, query } = uri_js_1.parse(url);
                return query ? `${path}?${query}` : path || '';
            };
            push = (url) => {
                const pathAndQuery = getPathAndQuery(url);
                if (pathAndQuery !== getPathAndQuery(window.location.href)) {
                    history.push(pathAndQuery);
                }
            };
            exports_4("default", Object.assign({}, history, { push }));
        }
    };
});
System.register("utils/mediaTypes", [], function (exports_5, context_5) {
    "use strict";
    var mediaTypes;
    var __moduleName = context_5 && context_5.id;
    return {
        setters: [],
        execute: function () {
            mediaTypes = {
                any: '*/*',
                hal: 'application/hal+json',
                json: 'application/json',
                markdown: 'text/markdown',
            };
            exports_5("default", mediaTypes);
        }
    };
});
System.register("utils/http", ["utils/mediaTypes"], function (exports_6, context_6) {
    "use strict";
    var mediaTypes_1, isJson, getBody, createRequestHeaders, getResponseHeaders, mapResponse, get, post, _delete, http;
    var __moduleName = context_6 && context_6.id;
    return {
        setters: [
            function (mediaTypes_1_1) {
                mediaTypes_1 = mediaTypes_1_1;
            }
        ],
        execute: function () {
            isJson = (mediaType) => mediaType === mediaTypes_1.default.json || (mediaType || '').endsWith('+json');
            getBody = (response, headers) => __awaiter(this, void 0, void 0, function* () {
                const body = yield response.text();
                if (!isJson(headers['content-type'])) {
                    return body;
                }
                try {
                    return JSON.parse(body);
                }
                catch (e) {
                    return {};
                }
            });
            createRequestHeaders = (headers) => new Headers(Object.keys(headers)
                .filter(key => headers[key])
                .reduce((akk, key) => (Object.assign({}, akk, { [key]: headers[key] })), {}));
            getResponseHeaders = (headers) => [...headers.entries()].reduce((acc, [key, value]) => value
                ? Object.assign({}, acc, { [key]: value }) : acc, {});
            mapResponse = (response) => __awaiter(this, void 0, void 0, function* () {
                const { ok, status, statusText, url } = response;
                const headers = getResponseHeaders(response.headers);
                return {
                    body: yield getBody(response, headers),
                    headers,
                    ok,
                    status,
                    statusText,
                    url,
                };
            });
            get = ({ link, headers = {} }) => fetch(link.href, {
                credentials: 'omit',
                headers: createRequestHeaders(Object.assign({ accept: link.type || mediaTypes_1.default.any }, headers)),
            }).then(mapResponse);
            post = ({ link, body, headers = {}, }) => fetch(link.href, {
                body: JSON.stringify(body),
                credentials: 'omit',
                headers: createRequestHeaders(Object.assign({ accept: link.type || mediaTypes_1.default.any, 'content-type': mediaTypes_1.default.json }, headers)),
                method: 'post',
            }).then(mapResponse);
            _delete = ({ link, headers = {} }) => fetch(link.href, {
                credentials: 'omit',
                headers: createRequestHeaders(Object.assign({ accept: link.type || mediaTypes_1.default.any }, headers)),
                method: 'delete',
            }).then(mapResponse);
            http = {
                delete: _delete,
                get,
                post,
            };
            exports_6("default", http);
        }
    };
});
System.register("utils/preventDefault", [], function (exports_7, context_7) {
    "use strict";
    var preventDefault;
    var __moduleName = context_7 && context_7.id;
    return {
        setters: [],
        execute: function () {
            preventDefault = (cb) => e => {
                e.preventDefault();
                cb();
            };
            exports_7("default", preventDefault);
        }
    };
});
System.register("utils/hal", ["url"], function (exports_8, context_8) {
    "use strict";
    var url_1, resolveLinks, normalizeEmbedded, normalizeLinks, normalizeResource;
    var __moduleName = context_8 && context_8.id;
    return {
        setters: [
            function (url_1_1) {
                url_1 = url_1_1;
            }
        ],
        execute: function () {
            resolveLinks = (url, links) => Object.keys(links).reduce((akk, rel) => (Object.assign({}, akk, { [rel]: links[rel].map((_a) => {
                    var { href } = _a, link = __rest(_a, ["href"]);
                    return (Object.assign({}, link, { href: url_1.default.resolve(url, href || './'), rel }));
                }) })), 
            // tslint:disable-next-line:no-object-literal-type-assertion
            {});
            normalizeEmbedded = (maybeArray) => (Array.isArray(maybeArray) ? maybeArray : [maybeArray]);
            normalizeLinks = (maybeArray) => Array.isArray(maybeArray) ? maybeArray : [maybeArray];
            normalizeResource = (_a) => {
                var { _links, _embedded } = _a, resource = __rest(_a, ["_links", "_embedded"]);
                return (Object.assign({}, resource, { _embedded: Object.keys(_embedded || {}).reduce((akk, rel) => (Object.assign({}, akk, { [rel]: normalizeEmbedded(_embedded[rel]).map(normalizeResource) })), {}), _links: Object.keys(_links || {}).reduce((akk, rel) => (Object.assign({}, akk, { [rel]: normalizeLinks(_links[rel]) })), {}) }));
            };
            exports_8("default", {
                normalizeResource,
                resolveLinks,
            });
        }
    };
});
System.register("utils/reactJsonTheme", ["base16", "invert-color"], function (exports_9, context_9) {
    "use strict";
    var base16_1, invert_color_1, invert, base16Themes, reactJsonTheme;
    var __moduleName = context_9 && context_9.id;
    return {
        setters: [
            function (base16_1_1) {
                base16_1 = base16_1_1;
            },
            function (invert_color_1_1) {
                invert_color_1 = invert_color_1_1;
            }
        ],
        execute: function () {
            invert = (scheme) => Object.keys(scheme).reduce((akk, key) => (Object.assign({}, akk, { [key]: key.startsWith('base')
                    ? // prettier-ignore
                        // @ts-ignore
                        invert_color_1.default(scheme[key])
                    : // prettier-ignore
                        // @ts-ignore
                        scheme[key] })), 
            // tslint:disable-next-line:no-object-literal-type-assertion
            {});
            base16Themes = {
                dark: Object.assign({}, base16_1.isotope, { base00: '#00000000' }),
                light: Object.assign({}, invert(base16_1.bright), { base00: '#00000000' }),
            };
            reactJsonTheme = (type = 'light') => base16Themes[type];
            exports_9("default", reactJsonTheme);
        }
    };
});
System.register("utils/clientVersion", [], function (exports_10, context_10) {
    "use strict";
    var clientVersion;
    var __moduleName = context_10 && context_10.id;
    return {
        setters: [],
        execute: function () {
            clientVersion = process.env.REACT_APP_CLIENT_VERSION;
            exports_10("default", clientVersion);
        }
    };
});
System.register("utils/index", ["utils/history", "utils/http", "utils/preventDefault", "utils/mediaTypes", "utils/hal", "utils/reactJsonTheme", "utils/clientVersion"], function (exports_11, context_11) {
    "use strict";
    var __moduleName = context_11 && context_11.id;
    return {
        setters: [
            function (history_2_1) {
                exports_11({
                    "history": history_2_1["default"]
                });
            },
            function (http_1_1) {
                exports_11({
                    "http": http_1_1["default"]
                });
            },
            function (preventDefault_1_1) {
                exports_11({
                    "preventDefault": preventDefault_1_1["default"]
                });
            },
            function (mediaTypes_2_1) {
                exports_11({
                    "mediaTypes": mediaTypes_2_1["default"]
                });
            },
            function (hal_1_1) {
                exports_11({
                    "hal": hal_1_1["default"]
                });
            },
            function (reactJsonTheme_1_1) {
                exports_11({
                    "reactJsonTheme": reactJsonTheme_1_1["default"]
                });
            },
            function (clientVersion_1_1) {
                exports_11({
                    "clientVersion": clientVersion_1_1["default"]
                });
            }
        ],
        execute: function () {
        }
    };
});
System.register("components/Hyperlink", ["@material-ui/core", "react", "utils/index", "components/NavigationProvider"], function (exports_12, context_12) {
    "use strict";
    var core_1, react_3, utils_1, NavigationProvider_1, styles, getLink, Hyperlink;
    var __moduleName = context_12 && context_12.id;
    return {
        setters: [
            function (core_1_1) {
                core_1 = core_1_1;
            },
            function (react_3_1) {
                react_3 = react_3_1;
            },
            function (utils_1_1) {
                utils_1 = utils_1_1;
            },
            function (NavigationProvider_1_1) {
                NavigationProvider_1 = NavigationProvider_1_1;
            }
        ],
        execute: function () {
            styles = ({ palette: { action: { active: color }, }, }) => ({
                hyperlink: {
                    '&:active': {
                        color,
                    },
                    '&:hover': {
                        color,
                    },
                    '&:visited': {
                        color,
                    },
                    color,
                },
            });
            getLink = (links, rel) => !links[rel] ? null : links[rel][0];
            Hyperlink = NavigationProvider_1.withNavigation()(core_1.withStyles(styles)(({ classes, _links, authorization, onNavigate, rel, }) => {
                const link = getLink(_links, rel);
                if (!link) {
                    // tslint:disable-next-line:no-console
                    console.warn(`Could not find link for rel ${rel}`, _links);
                    return null;
                }
                return (react_3.default.createElement("a", { href: link.href, className: classes.hyperlink, onClick: utils_1.preventDefault(() => onNavigate(link, authorization)) }, link.title));
            }));
            exports_12("default", Hyperlink);
        }
    };
});
System.register("reactive/index", ["react", "rxjs"], function (exports_13, context_13) {
    "use strict";
    var react_4, rxjs_1, createAction, createState, createLogger, connect;
    var __moduleName = context_13 && context_13.id;
    return {
        setters: [
            function (react_4_1) {
                react_4 = react_4_1;
            },
            function (rxjs_1_1) {
                rxjs_1 = rxjs_1_1;
            }
        ],
        execute: function () {
            exports_13("createAction", createAction = () => new rxjs_1.ReplaySubject(1));
            exports_13("createState", createState = (reducer$, initialState$) => initialState$
                .merge(reducer$)
                .scan(
            // @ts-ignore
            (state, [scope, reducer]) => 
            // tslint:disable-next-line:no-object-literal-type-assertion
            (Object.assign({}, state, { [scope]: reducer(state[scope]) })))
                .publishReplay(1)
                .refCount());
            createLogger = () => (state) => 
            // tslint:disable-next-line:no-console
            console.debug(state, typeof state);
            exports_13("connect", connect = (state$) => (WrappedComponent) => class extends react_4.Component {
                componentWillMount() {
                    const log = createLogger();
                    this.subscription = state$.do(log).subscribe(s => {
                        this.setState(s);
                    });
                }
                componentWillUnmount() {
                    this.subscription.unsubscribe();
                }
                render() {
                    // tslint:disable-next-line:no-object-literal-type-assertion
                    return react_4.default.createElement(WrappedComponent, Object.assign({}, this.state, this.props));
                }
            });
        }
    };
});
System.register("stream-store/rels", [], function (exports_14, context_14) {
    "use strict";
    var rels;
    var __moduleName = context_14 && context_14.id;
    return {
        setters: [],
        execute: function () {
            /* tslint:disable:object-literal-sort-keys */
            rels = {
                self: 'self',
                first: 'first',
                previous: 'previous',
                next: 'next',
                last: 'last',
                curies: 'curies',
                feed: 'streamStore:feed',
                message: 'streamStore:message',
                metadata: 'streamStore:metadata',
                index: 'streamStore:index',
                append: 'streamStore:append',
                deleteStream: 'streamStore:delete-stream',
                deleteMessage: 'streamStore:delete-message',
                find: 'streamStore:find',
                browse: 'streamStore:feed-browser',
            };
            exports_14("default", rels);
        }
    };
});
System.register("stream-store/navigation", ["stream-store/rels"], function (exports_15, context_15) {
    "use strict";
    var rels_1, feedNavigation;
    var __moduleName = context_15 && context_15.id;
    return {
        setters: [
            function (rels_1_1) {
                rels_1 = rels_1_1;
            }
        ],
        execute: function () {
            feedNavigation = [
                'first',
                'previous',
                'self',
                'next',
                'last',
                'metadata',
                'feed',
            ].map(key => rels_1.default[key]);
            exports_15("default", new Set(feedNavigation));
        }
    };
});
System.register("stream-store/actions", ["reactive/index", "utils/index"], function (exports_16, context_16) {
    "use strict";
    var reactive_1, utils_2, verbs, actions, getUrl;
    var __moduleName = context_16 && context_16.id;
    return {
        setters: [
            function (reactive_1_1) {
                reactive_1 = reactive_1_1;
            },
            function (utils_2_1) {
                utils_2 = utils_2_1;
            }
        ],
        execute: function () {
            verbs = Object.keys(utils_2.http);
            actions = verbs.reduce((akk, verb) => (Object.assign({}, akk, { [verb]: {
                    request: reactive_1.createAction(),
                    response: reactive_1.createAction(),
                } })), 
            // tslint:disable-next-line:no-object-literal-type-assertion
            {});
            verbs.forEach(verb => actions[verb].request
                .flatMap(request => utils_2.http[verb](request))
                .subscribe(response => actions[verb].response.next(response)));
            actions.get.response.subscribe(({ url }) => utils_2.history.push(url));
            getUrl = (location) => `${location.pathname}${location.search}${location.hash}`;
            utils_2.history.listen((location, action) => {
                if (action !== 'POP') {
                    return;
                }
                actions.get.request.next({
                    headers: {},
                    link: { href: getUrl(location) },
                });
            });
            exports_16("default", actions);
        }
    };
});
System.register("stream-store/store/mediaType", ["stream-store/actions"], function (exports_17, context_17) {
    "use strict";
    var actions_1, getMediaType, mediaType$;
    var __moduleName = context_17 && context_17.id;
    return {
        setters: [
            function (actions_1_1) {
                actions_1 = actions_1_1;
            }
        ],
        execute: function () {
            getMediaType = (headers) => headers['content-type'].split(';')[0];
            mediaType$ = actions_1.default.get.response.map(({ headers }) => getMediaType(headers));
            exports_17("default", mediaType$);
        }
    };
});
System.register("stream-store/store/hal/body", ["utils/index", "stream-store/actions", "stream-store/store/mediaType"], function (exports_18, context_18) {
    "use strict";
    var utils_3, actions_2, mediaType_1, body$;
    var __moduleName = context_18 && context_18.id;
    return {
        setters: [
            function (utils_3_1) {
                utils_3 = utils_3_1;
            },
            function (actions_2_1) {
                actions_2 = actions_2_1;
            },
            function (mediaType_1_1) {
                mediaType_1 = mediaType_1_1;
            }
        ],
        execute: function () {
            body$ = actions_2.default.get.response
                .zip(mediaType_1.default)
                .filter(([, mediaType]) => mediaType === utils_3.mediaTypes.hal)
                .map(([{ body }]) => utils_3.hal.normalizeResource(body));
            exports_18("default", body$);
        }
    };
});
System.register("stream-store/store/hal/forms", ["stream-store/store/hal/body"], function (exports_19, context_19) {
    "use strict";
    var body_1, isJsonSchema, forms$;
    var __moduleName = context_19 && context_19.id;
    return {
        setters: [
            function (body_1_1) {
                body_1 = body_1_1;
            }
        ],
        execute: function () {
            isJsonSchema = (schema) => schema && schema.$schema && schema.$schema.endsWith('schema#');
            forms$ = body_1.default
                .map(({ _embedded }) => _embedded)
                .map(embedded => Object.keys(embedded)
                .filter(rel => isJsonSchema(embedded[rel][0]))
                .reduce((akk, rel) => (Object.assign({}, akk, { [rel]: embedded[rel][0] })), 
            // tslint:disable-next-line:no-object-literal-type-assertion
            {}));
            exports_19("default", forms$);
        }
    };
});
System.register("stream-store/store/hal/url", ["stream-store/actions"], function (exports_20, context_20) {
    "use strict";
    var actions_3, url$;
    var __moduleName = context_20 && context_20.id;
    return {
        setters: [
            function (actions_3_1) {
                actions_3 = actions_3_1;
            }
        ],
        execute: function () {
            url$ = actions_3.default.get.response.map(({ url }) => url);
            exports_20("default", url$);
        }
    };
});
System.register("stream-store/store/hal/links", ["utils/index", "stream-store/store/hal/body", "stream-store/store/hal/url"], function (exports_21, context_21) {
    "use strict";
    var utils_4, body_2, url_2, links$;
    var __moduleName = context_21 && context_21.id;
    return {
        setters: [
            function (utils_4_1) {
                utils_4 = utils_4_1;
            },
            function (body_2_1) {
                body_2 = body_2_1;
            },
            function (url_2_1) {
                url_2 = url_2_1;
            }
        ],
        execute: function () {
            links$ = body_2.default
                .zip(url_2.default)
                .map(([{ _links }, url]) => utils_4.hal.resolveLinks(url, _links));
            exports_21("default", links$);
        }
    };
});
System.register("stream-store/store/hal/loading", ["rxjs", "stream-store/actions"], function (exports_22, context_22) {
    "use strict";
    var rxjs_2, actions_4, verbs, requests$, responses$, delayedRequests$, loading$;
    var __moduleName = context_22 && context_22.id;
    return {
        setters: [
            function (rxjs_2_1) {
                rxjs_2 = rxjs_2_1;
            },
            function (actions_4_1) {
                actions_4 = actions_4_1;
            }
        ],
        execute: function () {
            verbs = Object.keys(actions_4.default);
            requests$ = rxjs_2.Observable.merge(...verbs.map((verb) => actions_4.default[verb].request));
            responses$ = rxjs_2.Observable.merge(...verbs.map((verb) => actions_4.default[verb].response));
            delayedRequests$ = requests$.delay(1000);
            loading$ = requests$
                .timestamp()
                .combineLatest(responses$.timestamp(), delayedRequests$.timestamp(), ({ timestamp: requestTs }, { timestamp: responseTs }, { timestamp: delayedTs }) => requestTs > responseTs &&
                delayedTs > responseTs &&
                delayedTs >= requestTs);
            exports_22("default", loading$);
        }
    };
});
System.register("stream-store/store/hal/index", ["stream-store/store/hal/body", "stream-store/store/hal/forms", "stream-store/store/hal/links", "stream-store/store/hal/loading", "stream-store/store/hal/url"], function (exports_23, context_23) {
    "use strict";
    var body_3, forms_1, links_1, loading_1, url_3;
    var __moduleName = context_23 && context_23.id;
    return {
        setters: [
            function (body_3_1) {
                body_3 = body_3_1;
            },
            function (forms_1_1) {
                forms_1 = forms_1_1;
            },
            function (links_1_1) {
                links_1 = links_1_1;
            },
            function (loading_1_1) {
                loading_1 = loading_1_1;
            },
            function (url_3_1) {
                url_3 = url_3_1;
            }
        ],
        execute: function () {
            exports_23("default", {
                body$: body_3.default,
                forms$: forms_1.default,
                links$: links_1.default,
                loading$: loading_1.default,
                url$: url_3.default,
            });
        }
    };
});
System.register("stream-store/store/markdown", ["stream-store/actions", "utils/index", "stream-store/store/mediaType"], function (exports_24, context_24) {
    "use strict";
    var actions_5, utils_5, mediaType_2, body$;
    var __moduleName = context_24 && context_24.id;
    return {
        setters: [
            function (actions_5_1) {
                actions_5 = actions_5_1;
            },
            function (utils_5_1) {
                utils_5 = utils_5_1;
            },
            function (mediaType_2_1) {
                mediaType_2 = mediaType_2_1;
            }
        ],
        execute: function () {
            body$ = actions_5.default.get.response
                .zip(mediaType_2.default)
                .filter(([, mediaType]) => mediaType === utils_5.mediaTypes.markdown)
                .map(([{ body }]) => body);
            exports_24("default", {
                body$,
            });
        }
    };
});
System.register("stream-store/store/index", ["stream-store/store/hal/index", "stream-store/store/markdown", "stream-store/store/mediaType"], function (exports_25, context_25) {
    "use strict";
    var hal_2, markdown_1, mediaType_3;
    var __moduleName = context_25 && context_25.id;
    return {
        setters: [
            function (hal_2_1) {
                hal_2 = hal_2_1;
            },
            function (markdown_1_1) {
                markdown_1 = markdown_1_1;
            },
            function (mediaType_3_1) {
                mediaType_3 = mediaType_3_1;
            }
        ],
        execute: function () {
            exports_25("default", {
                hal$: hal_2.default,
                markdown$: markdown_1.default,
                mediaType$: mediaType_3.default,
            });
        }
    };
});
System.register("stream-store/Viewer/HalViewer/Home", ["components/index", "inflector-js", "react", "reactive/index", "rxjs", "stream-store/rels", "stream-store/store/index", "utils/index"], function (exports_26, context_26) {
    "use strict";
    var components_1, inflector_js_1, react_5, reactive_2, rxjs_3, rels_2, store_1, utils_6, provider$, versions$, info$, recent$, state$, InfoLine, Info, Index;
    var __moduleName = context_26 && context_26.id;
    return {
        setters: [
            function (components_1_1) {
                components_1 = components_1_1;
            },
            function (inflector_js_1_1) {
                inflector_js_1 = inflector_js_1_1;
            },
            function (react_5_1) {
                react_5 = react_5_1;
            },
            function (reactive_2_1) {
                reactive_2 = reactive_2_1;
            },
            function (rxjs_3_1) {
                rxjs_3 = rxjs_3_1;
            },
            function (rels_2_1) {
                rels_2 = rels_2_1;
            },
            function (store_1_1) {
                store_1 = store_1_1;
            },
            function (utils_6_1) {
                utils_6 = utils_6_1;
            }
        ],
        execute: function () {
            provider$ = store_1.default.hal$.body$.map(({ provider }) => provider);
            versions$ = store_1.default.hal$.body$.map(({ versions }) => versions);
            info$ = provider$.zip(versions$).map(([provider, versions]) => [
                {
                    id: 'Provider',
                    value: inflector_js_1.default.camel2words(inflector_js_1.default.underscore(provider)),
                },
            ]
                .concat(Object.keys(versions).map(key => ({
                id: `${inflector_js_1.default.camel2words(inflector_js_1.default.underscore(key))} Version`,
                value: versions[key],
            })))
                .concat({
                id: 'Client Version',
                value: utils_6.clientVersion,
            }));
            recent$ = store_1.default.hal$.body$.map(({ _embedded = {} }) => _embedded[rels_2.default.feed]);
            state$ = reactive_2.createState(rxjs_3.Observable.merge(info$.map(info => ['info', () => info]), recent$.map(recent => ['recent', () => recent])), rxjs_3.Observable.of({ recent: [], info: [] }));
            InfoLine = ({ id, value }) => (react_5.default.createElement(components_1.Table.Row, null,
                react_5.default.createElement(components_1.Table.Cell, null,
                    react_5.default.createElement("strong", null, id)),
                react_5.default.createElement(components_1.Table.Cell, null, value)));
            Info = ({ info }) => (react_5.default.createElement(components_1.Table, null,
                react_5.default.createElement(components_1.Table.Head, null,
                    react_5.default.createElement(components_1.Table.Row, null,
                        react_5.default.createElement(components_1.Table.Cell, { colSpan: 2 }, 'Server Information'))),
                react_5.default.createElement(components_1.Table.Body, null, info.map(({ id, value }) => (react_5.default.createElement(InfoLine, { key: id, id: id, value: value }))))));
            Index = ({ info }) => (react_5.default.createElement("section", null,
                react_5.default.createElement(Info, { info: info })));
            exports_26("default", reactive_2.connect(state$)(Index));
        }
    };
});
System.register("stream-store/Viewer/HalViewer/components/StreamHeader", ["components/index", "react"], function (exports_27, context_27) {
    "use strict";
    var components_2, react_6, nowrap, StreamHeader;
    var __moduleName = context_27 && context_27.id;
    return {
        setters: [
            function (components_2_1) {
                components_2 = components_2_1;
            },
            function (react_6_1) {
                react_6 = react_6_1;
            }
        ],
        execute: function () {
            nowrap = { whiteSpace: 'nowrap' };
            StreamHeader = () => (react_6.default.createElement(components_2.Table.Head, null,
                react_6.default.createElement(components_2.Table.Row, null,
                    react_6.default.createElement(components_2.Table.Cell, { style: nowrap }, 'Stream Id'),
                    react_6.default.createElement(components_2.Table.Cell, { style: nowrap }, 'Message Id'),
                    react_6.default.createElement(components_2.Table.Cell, { style: nowrap }, 'Created UTC'),
                    react_6.default.createElement(components_2.Table.Cell, { style: nowrap }, 'Type'),
                    react_6.default.createElement(components_2.Table.Cell, { style: { width: '100%' } }, 'Stream Id@Version'),
                    react_6.default.createElement(components_2.Table.Cell, { style: nowrap }, 'Position'))));
            exports_27("default", StreamHeader);
        }
    };
});
System.register("stream-store/Viewer/HalViewer/components/StreamMessageDetails", ["components/index", "react", "stream-store/rels"], function (exports_28, context_28) {
    "use strict";
    var components_3, react_7, rels_3, nowrap, StreamMessageDetails;
    var __moduleName = context_28 && context_28.id;
    return {
        setters: [
            function (components_3_1) {
                components_3 = components_3_1;
            },
            function (react_7_1) {
                react_7 = react_7_1;
            },
            function (rels_3_1) {
                rels_3 = rels_3_1;
            }
        ],
        execute: function () {
            nowrap = { whiteSpace: 'nowrap' };
            StreamMessageDetails = ({ messageId, createdUtc, position, streamId, streamVersion, type, _links, }) => (react_7.default.createElement(components_3.Table.Row, null,
                react_7.default.createElement(components_3.Table.Cell, { style: nowrap },
                    react_7.default.createElement(components_3.Hyperlink, { _links: _links, rel: rels_3.default.feed })),
                react_7.default.createElement(components_3.Table.Cell, { style: nowrap }, messageId),
                react_7.default.createElement(components_3.Table.Cell, { style: nowrap }, createdUtc),
                react_7.default.createElement(components_3.Table.Cell, { style: nowrap }, type),
                react_7.default.createElement(components_3.Table.Cell, { style: { width: '100%' } },
                    react_7.default.createElement(components_3.Hyperlink, { _links: _links, rel: rels_3.default.self })),
                react_7.default.createElement(components_3.Table.Cell, { numeric: true }, position)));
            exports_28("default", StreamMessageDetails);
        }
    };
});
System.register("themes", ["@material-ui/core", "rxjs", "reactive/index"], function (exports_29, context_29) {
    "use strict";
    var core_2, rxjs_4, reactive_3, palette, typography, createTheme, actions, paletteTypeKey, loadPaletteType, savePaletteType, defaultTheme, theme$;
    var __moduleName = context_29 && context_29.id;
    return {
        setters: [
            function (core_2_1) {
                core_2 = core_2_1;
            },
            function (rxjs_4_1) {
                rxjs_4 = rxjs_4_1;
            },
            function (reactive_3_1) {
                reactive_3 = reactive_3_1;
            }
        ],
        execute: function () {
            palette = (type) => ({
                action: {
                    active: '#42c0fb',
                },
                type,
            });
            typography = {
                useNextVariants: true,
            };
            createTheme = (type) => core_2.createMuiTheme({
                palette: palette(type),
                typography,
            });
            actions = {
                type: reactive_3.createAction(),
            };
            paletteTypeKey = 'paletteType';
            loadPaletteType = () => {
                const type = window.localStorage.getItem(paletteTypeKey);
                return type === 'dark' ? 'dark' : 'light';
            };
            savePaletteType = (type) => window.localStorage.setItem(paletteTypeKey, type);
            defaultTheme = createTheme(loadPaletteType());
            theme$ = reactive_3.createState(actions.type.map(() => [
                'theme',
                ({ palette: { type } }) => createTheme(type === 'light' ? 'dark' : 'light'),
            ]), rxjs_4.Observable.of({
                theme: defaultTheme,
            })).map(({ theme }) => theme);
            theme$.subscribe(({ palette: { type } }) => savePaletteType(type));
            exports_29("default", {
                actions,
                defaultTheme,
                theme$,
            });
        }
    };
});
System.register("stream-store/Viewer/HalViewer/components/JsonViewer", ["@material-ui/core", "components/index", "react", "react-json-view", "reactive/index", "rxjs", "stream-store/rels", "themes", "uri-template", "utils/index"], function (exports_30, context_30) {
    "use strict";
    var core_3, components_4, react_8, react_json_view_1, reactive_4, rxjs_5, rels_4, themes_1, uri_template_1, utils_7, isPotentialStreamId, getStreamLinks, style, JsonViewer, state$, ThemedJsonViewer;
    var __moduleName = context_30 && context_30.id;
    return {
        setters: [
            function (core_3_1) {
                core_3 = core_3_1;
            },
            function (components_4_1) {
                components_4 = components_4_1;
            },
            function (react_8_1) {
                react_8 = react_8_1;
            },
            function (react_json_view_1_1) {
                react_json_view_1 = react_json_view_1_1;
            },
            function (reactive_4_1) {
                reactive_4 = reactive_4_1;
            },
            function (rxjs_5_1) {
                rxjs_5 = rxjs_5_1;
            },
            function (rels_4_1) {
                rels_4 = rels_4_1;
            },
            function (themes_1_1) {
                themes_1 = themes_1_1;
            },
            function (uri_template_1_1) {
                uri_template_1 = uri_template_1_1;
            },
            function (utils_7_1) {
                utils_7 = utils_7_1;
            }
        ],
        execute: function () {
            isPotentialStreamId = (data) => typeof data === 'number' || typeof data === 'string';
            getStreamLinks = ({ _embedded }) => _embedded[rels_4.default.feed] || [];
            style = {
                drawerPaper: {
                    width: 480,
                },
                streamId: {
                    '&:hover': {
                        textDecoration: 'underline',
                    },
                },
            };
            JsonViewer = class JsonViewer extends react_8.PureComponent {
                constructor() {
                    super(...arguments);
                    this.state = {
                        loading: false,
                        open: false,
                        streams: [],
                    };
                    this._handlePotentialStreamIdClick = ({ value: pattern, }) => __awaiter(this, void 0, void 0, function* () {
                        if (!isPotentialStreamId(pattern)) {
                            return;
                        }
                        const { authorization, _links } = this.props;
                        this.setState({
                            loading: true,
                            open: true,
                        });
                        if (!_links || !_links[rels_4.default.browse]) {
                            return;
                        }
                        const template = uri_template_1.default.parse(decodeURI(_links[rels_4.default.browse][0].href));
                        const responses = yield Promise.all([...new Set([pattern, String(pattern).replace(/-/g, '')])].map(p => utils_7.http.get({
                            headers: { authorization },
                            link: {
                                href: template.expand({ p, t: 'e' }),
                            },
                        })));
                        const streams = this._getStreams(responses);
                        this.setState({
                            loading: false,
                            streams,
                        });
                    });
                    this._getStreams = (responses) => Object.values(responses
                        .flatMap(({ body }) => getStreamLinks(utils_7.hal.normalizeResource(body)))
                        .map((_a) => {
                        var { _links } = _a, resource = __rest(_a, ["_links"]);
                        return (Object.assign({}, resource, { _links: utils_7.hal.resolveLinks('../../', _links) }));
                    }));
                    this._handlePotentialStreamIdClose = () => this.setState({
                        open: false,
                    });
                }
                render() {
                    const { json, classes, theme } = this.props;
                    if (!json) {
                        return null;
                    }
                    const { streams, loading, open } = this.state;
                    return (react_8.default.createElement("div", { className: classes.drawerPaper },
                        react_8.default.createElement(react_json_view_1.default, { name: null, src: json, theme: theme, onSelect: this._handlePotentialStreamIdClick }),
                        react_8.default.createElement(core_3.Drawer, { variant: 'temporary', open: open, onClose: this._handlePotentialStreamIdClose, anchor: 'right', classes: {
                                paper: classes.drawerPaper,
                            } },
                            react_8.default.createElement(components_4.StreamBrowser, { streams: streams, loading: loading }))));
                }
            };
            state$ = reactive_4.createState(themes_1.default.theme$.map(({ palette: { type } }) => [
                'theme',
                () => utils_7.reactJsonTheme(type),
            ]), rxjs_5.Observable.of({
                theme: utils_7.reactJsonTheme(),
            }));
            ThemedJsonViewer = reactive_4.connect(state$)(JsonViewer);
            exports_30("default", components_4.withNavigation()(core_3.withStyles(style)(ThemedJsonViewer)));
        }
    };
});
System.register("stream-store/Viewer/HalViewer/components/index", ["stream-store/Viewer/HalViewer/components/StreamHeader", "stream-store/Viewer/HalViewer/components/StreamMessageDetails", "stream-store/Viewer/HalViewer/components/JsonViewer"], function (exports_31, context_31) {
    "use strict";
    var __moduleName = context_31 && context_31.id;
    return {
        setters: [
            function (StreamHeader_1_1) {
                exports_31({
                    "StreamHeader": StreamHeader_1_1["default"]
                });
            },
            function (StreamMessageDetails_1_1) {
                exports_31({
                    "StreamMessageDetails": StreamMessageDetails_1_1["default"]
                });
            },
            function (JsonViewer_1_1) {
                exports_31({
                    "JsonViewer": JsonViewer_1_1["default"]
                });
            }
        ],
        execute: function () {
        }
    };
});
System.register("stream-store/Viewer/HalViewer/Stream", ["components/index", "react", "reactive/index", "rxjs", "stream-store/rels", "stream-store/store/index", "utils/index", "stream-store/Viewer/HalViewer/components/index"], function (exports_32, context_32) {
    "use strict";
    var components_5, react_9, reactive_5, rxjs_6, rels_5, store_2, utils_8, components_6, messages$, state$, Messages, Stream;
    var __moduleName = context_32 && context_32.id;
    return {
        setters: [
            function (components_5_1) {
                components_5 = components_5_1;
            },
            function (react_9_1) {
                react_9 = react_9_1;
            },
            function (reactive_5_1) {
                reactive_5 = reactive_5_1;
            },
            function (rxjs_6_1) {
                rxjs_6 = rxjs_6_1;
            },
            function (rels_5_1) {
                rels_5 = rels_5_1;
            },
            function (store_2_1) {
                store_2 = store_2_1;
            },
            function (utils_8_1) {
                utils_8 = utils_8_1;
            },
            function (components_6_1) {
                components_6 = components_6_1;
            }
        ],
        execute: function () {
            messages$ = store_2.default.hal$.body$
                .zip(store_2.default.hal$.url$)
                .map(([{ _embedded }, url]) => _embedded[rels_5.default.message].map((_a) => {
                var { _links } = _a, message = __rest(_a, ["_links"]);
                return (Object.assign({}, message, { _links: utils_8.hal.resolveLinks(url, _links) }));
            }));
            state$ = reactive_5.createState(messages$.map(messages => ['messages', () => messages]), rxjs_6.Observable.of({ messages: [] }));
            Messages = ({ messages }) => (react_9.default.createElement(components_5.Table, null,
                react_9.default.createElement(components_6.StreamHeader, null),
                react_9.default.createElement(components_5.Table.Body, null, messages.map(message => (react_9.default.createElement(components_6.StreamMessageDetails, Object.assign({ key: message.messageId }, message)))))));
            Stream = ({ messages = [], }) => (react_9.default.createElement("section", null,
                react_9.default.createElement(Messages, { messages: messages })));
            exports_32("default", reactive_5.connect(state$)(Stream));
        }
    };
});
System.register("stream-store/Viewer/HalViewer/StreamBrowser", ["components/index", "react", "reactive/index", "rxjs", "stream-store/rels", "stream-store/store/index"], function (exports_33, context_33) {
    "use strict";
    var components_7, react_10, reactive_6, rxjs_7, rels_6, store_3, streams$, state$, StreamBrowserComponent;
    var __moduleName = context_33 && context_33.id;
    return {
        setters: [
            function (components_7_1) {
                components_7 = components_7_1;
            },
            function (react_10_1) {
                react_10 = react_10_1;
            },
            function (reactive_6_1) {
                reactive_6 = reactive_6_1;
            },
            function (rxjs_7_1) {
                rxjs_7 = rxjs_7_1;
            },
            function (rels_6_1) {
                rels_6 = rels_6_1;
            },
            function (store_3_1) {
                store_3 = store_3_1;
            }
        ],
        execute: function () {
            streams$ = store_3.default.hal$.body$.map(({ _embedded = {} }) => _embedded[rels_6.default.feed] || []);
            state$ = reactive_6.createState(streams$.map(streams => ['streams', () => streams]), rxjs_7.Observable.of({ loading: false, streams: [] }));
            StreamBrowserComponent = ({ streams, loading }) => (react_10.default.createElement(components_7.StreamBrowser, { loading: loading, streams: streams }));
            exports_33("default", reactive_6.connect(state$)(StreamBrowserComponent));
        }
    };
});
System.register("icons/SqlStreamStore", ["@material-ui/core", "react"], function (exports_34, context_34) {
    "use strict";
    var core_4, react_11, SqlStreamStore;
    var __moduleName = context_34 && context_34.id;
    return {
        setters: [
            function (core_4_1) {
                core_4 = core_4_1;
            },
            function (react_11_1) {
                react_11 = react_11_1;
            }
        ],
        execute: function () {
            /* eslint-disable max-len */
            SqlStreamStore = props => (react_11.default.createElement(core_4.SvgIcon, Object.assign({}, props, { viewBox: '0 0 448.687 627.153' }),
                react_11.default.createElement("g", { transform: 'translate(-88.5 -116.776)' },
                    react_11.default.createElement("ellipse", { ry: '100.857', rx: '224.285', cy: '217.633', cx: '312.902' }),
                    react_11.default.createElement("path", { d: 'M537.187 273.963A265.714 157.143 0 0 1 312.33 347.79a265.714 157.143 0 0 1-223.713-72.543v78.732a265.714 157.143 0 0 0 223.713 72.668 265.714 157.143 0 0 0 224.857-73.543v-79.142z' }),
                    react_11.default.createElement("path", { d: 'M537.187 379.734a265.714 157.143 0 0 1-224.857 73.828 265.714 157.143 0 0 1-223.713-72.543v78.732A265.714 157.143 0 0 0 312.33 532.42a265.714 157.143 0 0 0 224.857-73.543v-79.142z' }),
                    react_11.default.createElement("path", { d: 'M537.187 484.563A265.714 157.143 0 0 1 312.33 558.39a265.714 157.143 0 0 1-223.713-72.543v78.732a265.714 157.143 0 0 0 223.713 72.668 265.714 157.143 0 0 0 224.857-73.543v-79.142z' }),
                    react_11.default.createElement("path", { d: 'M88.617 592.518v78.733a265.714 157.143 0 0 0 216.57 72.459v.219h232v-79h-232v.285h-.285v-.375a265.714 157.143 0 0 1-216.285-72.32z' }),
                    react_11.default.createElement("path", { d: 'M88.5 116.8v66.788A224.285 100.857 0 0 1 217.816 116.8H88.5z' }))));
            exports_34("default", SqlStreamStore);
        }
    };
});
System.register("icons/mui/LightbulbFull", ["@material-ui/core/SvgIcon", "react"], function (exports_35, context_35) {
    "use strict";
    var SvgIcon_1, react_12, LightbulbFull;
    var __moduleName = context_35 && context_35.id;
    return {
        setters: [
            function (SvgIcon_1_1) {
                SvgIcon_1 = SvgIcon_1_1;
            },
            function (react_12_1) {
                react_12 = react_12_1;
            }
        ],
        execute: function () {
            LightbulbFull = (props) => (react_12.default.createElement(SvgIcon_1.default, Object.assign({}, props),
                react_12.default.createElement("path", { d: 'm9,21c0,0.55 0.45,1 1,1l4,0c0.55,0 1,-0.45 1,-1l0,-1l-6,0l0,1zm3,-19c-3.86,0 -7,3.14 -7,7c0,2.38 1.19,4.47 3,5.74l0,2.26c0,0.55 0.45,1 1,1l6,0c0.55,0 1,-0.45 1,-1l0,-2.26c1.81,-1.27 3,-3.36 3,-5.74c0,-3.86 -3.14,-7 -7,-7z' })));
            exports_35("default", LightbulbFull);
        }
    };
});
System.register("icons/mui/LightbulbOutline", ["@material-ui/core/SvgIcon", "react"], function (exports_36, context_36) {
    "use strict";
    var SvgIcon_2, react_13, LightbulbOutline;
    var __moduleName = context_36 && context_36.id;
    return {
        setters: [
            function (SvgIcon_2_1) {
                SvgIcon_2 = SvgIcon_2_1;
            },
            function (react_13_1) {
                react_13 = react_13_1;
            }
        ],
        execute: function () {
            LightbulbOutline = (props) => (react_13.default.createElement(SvgIcon_2.default, Object.assign({}, props),
                react_13.default.createElement("path", { d: 'M9 21c0 .55.45 1 1 1h4c.55 0 1-.45 1-1v-1H9v1zm3-19C8.14 2 5 5.14 5 9c0 2.38 1.19 4.47 3 5.74V17c0 .55.45 1 1 1h6c.55 0 1-.45 1-1v-2.26c1.81-1.27 3-3.36 3-5.74 0-3.86-3.14-7-7-7zm2.85 11.1l-.85.6V16h-4v-2.3l-.85-.6C7.8 12.16 7 10.63 7 9c0-2.76 2.24-5 5-5s5 2.24 5 5c0 1.63-.8 3.16-2.15 4.1z' })));
            LightbulbOutline.muiName = 'SvgIcon';
            exports_36("default", LightbulbOutline);
        }
    };
});
System.register("icons/mui/index", ["icons/mui/LightbulbFull", "icons/mui/LightbulbOutline"], function (exports_37, context_37) {
    "use strict";
    var __moduleName = context_37 && context_37.id;
    return {
        setters: [
            function (LightbulbFull_1_1) {
                exports_37({
                    "LightbulbFull": LightbulbFull_1_1["default"]
                });
            },
            function (LightbulbOutline_1_1) {
                exports_37({
                    "LightbulbOutline": LightbulbOutline_1_1["default"]
                });
            }
        ],
        execute: function () {
        }
    };
});
System.register("icons/index", ["icons/SqlStreamStore", "@material-ui/icons/Code", "@material-ui/icons/Close", "@material-ui/icons/CheckCircle", "@material-ui/icons/Warning", "@material-ui/icons/Error", "@material-ui/icons/Info", "@material-ui/icons/Publish", "@material-ui/icons/Settings", "@material-ui/icons/Notes", "@material-ui/icons/DeleteForever", "@material-ui/icons/FirstPage", "@material-ui/icons/LastPage", "@material-ui/icons/ChevronLeft", "@material-ui/icons/ChevronRight", "@material-ui/icons/RssFeed", "@material-ui/icons/Refresh", "@material-ui/icons/SpaceBar", "@material-ui/icons/Search", "@material-ui/icons/List", "@material-ui/icons/Help", "icons/mui/index"], function (exports_38, context_38) {
    "use strict";
    var __moduleName = context_38 && context_38.id;
    return {
        setters: [
            function (SqlStreamStore_1_1) {
                exports_38({
                    "SqlStreamStore": SqlStreamStore_1_1["default"]
                });
            },
            function (Code_1_1) {
                exports_38({
                    "Code": Code_1_1["default"]
                });
            },
            function (Close_1_1) {
                exports_38({
                    "Close": Close_1_1["default"]
                });
            },
            function (CheckCircle_1_1) {
                exports_38({
                    "CheckCircle": CheckCircle_1_1["default"]
                });
            },
            function (Warning_1_1) {
                exports_38({
                    "Warning": Warning_1_1["default"]
                });
            },
            function (Error_1_1) {
                exports_38({
                    "Error": Error_1_1["default"]
                });
            },
            function (Info_1_1) {
                exports_38({
                    "Info": Info_1_1["default"]
                });
            },
            function (Publish_1_1) {
                exports_38({
                    "Publish": Publish_1_1["default"]
                });
            },
            function (Settings_1_1) {
                exports_38({
                    "Settings": Settings_1_1["default"]
                });
            },
            function (Notes_1_1) {
                exports_38({
                    "Notes": Notes_1_1["default"]
                });
            },
            function (DeleteForever_1_1) {
                exports_38({
                    "DeleteForever": DeleteForever_1_1["default"]
                });
            },
            function (FirstPage_1_1) {
                exports_38({
                    "FirstPage": FirstPage_1_1["default"]
                });
            },
            function (LastPage_1_1) {
                exports_38({
                    "LastPage": LastPage_1_1["default"]
                });
            },
            function (ChevronLeft_1_1) {
                exports_38({
                    "ChevronLeft": ChevronLeft_1_1["default"]
                });
            },
            function (ChevronRight_1_1) {
                exports_38({
                    "ChevronRight": ChevronRight_1_1["default"]
                });
            },
            function (RssFeed_1_1) {
                exports_38({
                    "RssFeed": RssFeed_1_1["default"]
                });
            },
            function (Refresh_1_1) {
                exports_38({
                    "Refresh": Refresh_1_1["default"]
                });
            },
            function (SpaceBar_1_1) {
                exports_38({
                    "SpaceBar": SpaceBar_1_1["default"]
                });
            },
            function (Search_1_1) {
                exports_38({
                    "Search": Search_1_1["default"]
                });
            },
            function (List_1_1) {
                exports_38({
                    "List": List_1_1["default"]
                });
            },
            function (Help_1_1) {
                exports_38({
                    "Help": Help_1_1["default"]
                });
            },
            function (mui_1_1) {
                exports_38({
                    "LightbulbFull": mui_1_1["LightbulbFull"],
                    "LightbulbOutline": mui_1_1["LightbulbOutline"]
                });
            }
        ],
        execute: function () {
        }
    };
});
System.register("stream-store/Viewer/HalViewer/StreamMessage", ["@material-ui/core", "components/index", "icons/index", "react", "reactive/index", "rxjs", "stream-store/store/index", "stream-store/Viewer/HalViewer/components/index"], function (exports_39, context_39) {
    "use strict";
    var core_5, components_8, icons_1, react_14, reactive_7, rxjs_8, store_4, components_9, message$, state$, StreamMessageTabs, StreamMessage;
    var __moduleName = context_39 && context_39.id;
    return {
        setters: [
            function (core_5_1) {
                core_5 = core_5_1;
            },
            function (components_8_1) {
                components_8 = components_8_1;
            },
            function (icons_1_1) {
                icons_1 = icons_1_1;
            },
            function (react_14_1) {
                react_14 = react_14_1;
            },
            function (reactive_7_1) {
                reactive_7 = reactive_7_1;
            },
            function (rxjs_8_1) {
                rxjs_8 = rxjs_8_1;
            },
            function (store_4_1) {
                store_4 = store_4_1;
            },
            function (components_9_1) {
                components_9 = components_9_1;
            }
        ],
        execute: function () {
            message$ = store_4.default.hal$.body$.map((_a) => {
                var { payload, metadata } = _a, body = __rest(_a, ["payload", "metadata"]);
                return (Object.assign({}, body, { metadata,
                    payload }));
            });
            state$ = reactive_7.createState(message$.map(message => ['message', () => message]), rxjs_8.Observable.of({
                _embedded: {},
                _links: {},
                message: {
                    createdUtc: '',
                    messageId: '',
                    metadata: {},
                    payload: {},
                    position: 0,
                    streamId: '',
                    streamVersion: 0,
                    type: '',
                },
            }));
            StreamMessageTabs = class StreamMessageTabs extends react_14.PureComponent {
                constructor() {
                    super(...arguments);
                    this.state = {
                        value: 0,
                    };
                    this._handleChange = (e, value) => this.setState({ value });
                }
                render() {
                    const _a = this.props, { message: { payload, metadata } } = _a, props = __rest(_a, ["message"]);
                    const { value } = this.state;
                    return (react_14.default.createElement(core_5.Card, null,
                        react_14.default.createElement(core_5.CardActions, null,
                            react_14.default.createElement(core_5.Tabs, { value: value, onChange: this._handleChange, indicatorColor: 'primary' },
                                react_14.default.createElement(core_5.Tab, { label: react_14.default.createElement(core_5.Typography, { variant: 'body1' }, 'Data'), icon: react_14.default.createElement(core_5.Typography, null,
                                        react_14.default.createElement(icons_1.Notes, null)) }),
                                react_14.default.createElement(core_5.Tab, { label: react_14.default.createElement(core_5.Typography, { variant: 'body1' }, 'Metadata'), icon: react_14.default.createElement(core_5.Typography, null,
                                        react_14.default.createElement(icons_1.Settings, null)) }))),
                        react_14.default.createElement(core_5.CardContent, null,
                            value === 0 && react_14.default.createElement(components_9.JsonViewer, Object.assign({ json: payload }, props)),
                            value === 1 && react_14.default.createElement(components_9.JsonViewer, Object.assign({ json: metadata }, props)))));
                }
            };
            StreamMessage = (_a) => {
                var { message } = _a, props = __rest(_a, ["message"]);
                return (react_14.default.createElement("section", null,
                    react_14.default.createElement(components_8.Table, { style: { tableLayout: 'auto' } },
                        react_14.default.createElement(components_9.StreamHeader, null),
                        react_14.default.createElement(components_8.Table.Body, null,
                            react_14.default.createElement(components_9.StreamMessageDetails, Object.assign({}, message, props)))),
                    react_14.default.createElement(StreamMessageTabs, Object.assign({ message: message }, props))));
            };
            exports_39("default", reactive_7.connect(state$)(StreamMessage));
        }
    };
});
System.register("stream-store/Viewer/HalViewer/StreamMetadata", ["components/index", "react", "reactive/index", "rxjs", "stream-store/rels", "stream-store/store/index", "stream-store/Viewer/HalViewer/components/index"], function (exports_40, context_40) {
    "use strict";
    var components_10, react_15, reactive_8, rxjs_9, rels_7, store_5, components_11, metadata$, state$, nowrap, StreamMetadataHeader, StreamMetadataDetails, StreamMetadata;
    var __moduleName = context_40 && context_40.id;
    return {
        setters: [
            function (components_10_1) {
                components_10 = components_10_1;
            },
            function (react_15_1) {
                react_15 = react_15_1;
            },
            function (reactive_8_1) {
                reactive_8 = reactive_8_1;
            },
            function (rxjs_9_1) {
                rxjs_9 = rxjs_9_1;
            },
            function (rels_7_1) {
                rels_7 = rels_7_1;
            },
            function (store_5_1) {
                store_5 = store_5_1;
            },
            function (components_11_1) {
                components_11 = components_11_1;
            }
        ],
        execute: function () {
            metadata$ = store_5.default.hal$.body$.map(metadata => metadata);
            state$ = reactive_8.createState(metadata$.map(metadata => ['metadata', () => metadata]), rxjs_9.Observable.of({
                metadata: {
                    _embedded: {},
                    _links: {},
                    streamId: '',
                },
            }));
            nowrap = { whiteSpace: 'nowrap' };
            StreamMetadataHeader = () => (react_15.default.createElement(components_10.Table.Row, null,
                react_15.default.createElement(components_10.Table.Cell, null, 'Stream'),
                react_15.default.createElement(components_10.Table.Cell, null, 'Max Age'),
                react_15.default.createElement(components_10.Table.Cell, null, 'Max Count')));
            StreamMetadataDetails = ({ streamId, maxAge, maxCount, _links, }) => (react_15.default.createElement(components_10.Table.Row, null,
                react_15.default.createElement(components_10.Table.Cell, { style: nowrap },
                    react_15.default.createElement(components_10.Hyperlink, { _links: _links, rel: rels_7.default.feed })),
                react_15.default.createElement(components_10.Table.Cell, { style: nowrap, numeric: true }, maxAge),
                react_15.default.createElement(components_10.Table.Cell, { style: nowrap, numeric: true }, maxCount)));
            StreamMetadata = ({ metadata }) => (react_15.default.createElement("section", null,
                react_15.default.createElement(components_10.Table, { style: { tableLayout: 'auto' } },
                    react_15.default.createElement(components_10.Table.Head, null,
                        react_15.default.createElement(StreamMetadataHeader, null)),
                    react_15.default.createElement(components_10.Table.Body, null,
                        react_15.default.createElement(StreamMetadataDetails, Object.assign({}, metadata)))),
                react_15.default.createElement(components_11.JsonViewer, { json: metadata.metadataJson })));
            exports_40("default", reactive_8.connect(state$)(StreamMetadata));
        }
    };
});
System.register("stream-store/Viewer/HalViewer/Unrecognized", ["components/index", "react", "react-json-view", "reactive/index", "rxjs", "stream-store/store/index", "themes", "utils/index"], function (exports_41, context_41) {
    "use strict";
    var components_12, react_16, react_json_view_2, reactive_9, rxjs_10, store_6, themes_2, utils_9, isHyperlink, state$, UnrecognizedRelViewer;
    var __moduleName = context_41 && context_41.id;
    return {
        setters: [
            function (components_12_1) {
                components_12 = components_12_1;
            },
            function (react_16_1) {
                react_16 = react_16_1;
            },
            function (react_json_view_2_1) {
                react_json_view_2 = react_json_view_2_1;
            },
            function (reactive_9_1) {
                reactive_9 = reactive_9_1;
            },
            function (rxjs_10_1) {
                rxjs_10 = rxjs_10_1;
            },
            function (store_6_1) {
                store_6 = store_6_1;
            },
            function (themes_2_1) {
                themes_2 = themes_2_1;
            },
            function (utils_9_1) {
                utils_9 = utils_9_1;
            }
        ],
        execute: function () {
            isHyperlink = (name, namespace) => name === 'href' && namespace.filter(n => n === '_links').length > 0;
            state$ = reactive_9.createState(rxjs_10.Observable.merge(store_6.default.hal$.body$.map(src => ['src', () => src]), themes_2.default.theme$.map(({ palette: { type } }) => [
                'theme',
                () => utils_9.reactJsonTheme(type),
            ])), rxjs_10.Observable.of({
                src: {},
                theme: utils_9.reactJsonTheme(),
            }));
            UnrecognizedRelViewer = components_12.withNavigation()(class extends react_16.default.PureComponent {
                constructor() {
                    super(...arguments);
                    this._handlePotentialNavigation = ({ name, value, namespace, }) => {
                        const { authorization, onNavigate } = this.props;
                        if (!isHyperlink(name, namespace)) {
                            return;
                        }
                        onNavigate({
                            href: value,
                        }, authorization);
                    };
                }
                render() {
                    return (react_16.default.createElement(react_json_view_2.default, Object.assign({}, this.props, { onSelect: this._handlePotentialNavigation })));
                }
            });
            exports_41("default", reactive_9.connect(state$)(UnrecognizedRelViewer));
        }
    };
});
System.register("stream-store/Viewer/HalViewer/index", ["components/index", "react", "stream-store/actions", "stream-store/rels", "stream-store/Viewer/HalViewer/Home", "stream-store/Viewer/HalViewer/Stream", "stream-store/Viewer/HalViewer/StreamBrowser", "stream-store/Viewer/HalViewer/StreamMessage", "stream-store/Viewer/HalViewer/StreamMetadata", "stream-store/Viewer/HalViewer/Unrecognized"], function (exports_42, context_42) {
    "use strict";
    var components_13, react_17, actions_6, rels_8, Home_1, Stream_1, StreamBrowser_1, StreamMessage_1, StreamMetadata_1, Unrecognized_1, formActions, views, HalViewer;
    var __moduleName = context_42 && context_42.id;
    return {
        setters: [
            function (components_13_1) {
                components_13 = components_13_1;
            },
            function (react_17_1) {
                react_17 = react_17_1;
            },
            function (actions_6_1) {
                actions_6 = actions_6_1;
            },
            function (rels_8_1) {
                rels_8 = rels_8_1;
            },
            function (Home_1_1) {
                Home_1 = Home_1_1;
            },
            function (Stream_1_1) {
                Stream_1 = Stream_1_1;
            },
            function (StreamBrowser_1_1) {
                StreamBrowser_1 = StreamBrowser_1_1;
            },
            function (StreamMessage_1_1) {
                StreamMessage_1 = StreamMessage_1_1;
            },
            function (StreamMetadata_1_1) {
                StreamMetadata_1 = StreamMetadata_1_1;
            },
            function (Unrecognized_1_1) {
                Unrecognized_1 = Unrecognized_1_1;
            }
        ],
        execute: function () {
            formActions = {
                [rels_8.default.append]: actions_6.default.post,
                [rels_8.default.metadata]: actions_6.default.post,
                [rels_8.default.deleteStream]: actions_6.default.delete,
                [rels_8.default.deleteMessage]: actions_6.default.delete,
            };
            views = {
                [rels_8.default.feed]: Stream_1.default,
                [rels_8.default.message]: StreamMessage_1.default,
                [rels_8.default.index]: Home_1.default,
                [rels_8.default.metadata]: StreamMetadata_1.default,
                [rels_8.default.browse]: StreamBrowser_1.default,
                _unrecognized: Unrecognized_1.default,
            };
            HalViewer = ({ forms, _links, self, }) => (react_17.default.createElement("section", null,
                react_17.default.createElement(components_13.NavigationLinks, { _links: _links }),
                react_17.default.createElement(components_13.HyperMediaControls, { actions: formActions, forms: forms, _links: _links }),
                react_17.createElement(views[self] || views._unrecognized, {
                    _links,
                    forms,
                    self,
                })));
            exports_42("default", HalViewer);
        }
    };
});
System.register("stream-store/Viewer/MarkdownViewer/index", ["@material-ui/core", "react", "react-remarkable", "reactive/index", "rxjs", "stream-store/store/index"], function (exports_43, context_43) {
    "use strict";
    var core_6, react_18, react_remarkable_1, reactive_10, rxjs_11, store_7, body$, state$, MarkdownViewer;
    var __moduleName = context_43 && context_43.id;
    return {
        setters: [
            function (core_6_1) {
                core_6 = core_6_1;
            },
            function (react_18_1) {
                react_18 = react_18_1;
            },
            function (react_remarkable_1_1) {
                react_remarkable_1 = react_remarkable_1_1;
            },
            function (reactive_10_1) {
                reactive_10 = reactive_10_1;
            },
            function (rxjs_11_1) {
                rxjs_11 = rxjs_11_1;
            },
            function (store_7_1) {
                store_7 = store_7_1;
            }
        ],
        execute: function () {
            body$ = store_7.default.markdown$.body$.map(body => () => body);
            state$ = reactive_10.createState(body$.map(body => ['body', body]), rxjs_11.Observable.of({
                body: '',
            }));
            MarkdownViewer = ({ body }) => (react_18.default.createElement(core_6.Typography, null,
                react_18.default.createElement(react_remarkable_1.default, { options: {
                        typographer: true,
                    } }, body)));
            exports_43("default", reactive_10.connect(state$)(MarkdownViewer));
        }
    };
});
System.register("stream-store/Viewer/index", ["react", "utils/index", "stream-store/Viewer/HalViewer/index", "stream-store/Viewer/MarkdownViewer/index"], function (exports_44, context_44) {
    "use strict";
    var react_19, utils_10, HalViewer_1, MarkdownViewer_1, viewers, Viewer;
    var __moduleName = context_44 && context_44.id;
    return {
        setters: [
            function (react_19_1) {
                react_19 = react_19_1;
            },
            function (utils_10_1) {
                utils_10 = utils_10_1;
            },
            function (HalViewer_1_1) {
                HalViewer_1 = HalViewer_1_1;
            },
            function (MarkdownViewer_1_1) {
                MarkdownViewer_1 = MarkdownViewer_1_1;
            }
        ],
        execute: function () {
            viewers = {
                [utils_10.mediaTypes.markdown]: MarkdownViewer_1.default,
                [utils_10.mediaTypes.hal]: HalViewer_1.default,
            };
            Viewer = (_a) => {
                var { mediaType } = _a, props = __rest(_a, ["mediaType"]);
                return react_19.createElement(viewers[mediaType] || 'div', props);
            };
            exports_44("default", Viewer);
        }
    };
});
System.register("stream-store/index", ["stream-store/rels", "stream-store/navigation", "stream-store/store/index", "stream-store/actions", "stream-store/Viewer/index"], function (exports_45, context_45) {
    "use strict";
    var __moduleName = context_45 && context_45.id;
    return {
        setters: [
            function (rels_9_1) {
                exports_45({
                    "rels": rels_9_1["default"]
                });
            },
            function (navigation_1_1) {
                exports_45({
                    "navigation": navigation_1_1["default"]
                });
            },
            function (store_8_1) {
                exports_45({
                    "store": store_8_1["default"]
                });
            },
            function (actions_7_1) {
                exports_45({
                    "actions": actions_7_1["default"]
                });
            },
            function (Viewer_1_1) {
                exports_45({
                    "Viewer": Viewer_1_1["default"]
                });
            }
        ],
        execute: function () {
        }
    };
});
System.register("components/RelIcon", ["icons/index", "react", "stream-store/index"], function (exports_46, context_46) {
    "use strict";
    var icons_2, react_20, stream_store_1, fontIconByRel, RelIcon;
    var __moduleName = context_46 && context_46.id;
    return {
        setters: [
            function (icons_2_1) {
                icons_2 = icons_2_1;
            },
            function (react_20_1) {
                react_20 = react_20_1;
            },
            function (stream_store_1_1) {
                stream_store_1 = stream_store_1_1;
            }
        ],
        execute: function () {
            fontIconByRel = {
                [stream_store_1.rels.first]: icons_2.FirstPage,
                [stream_store_1.rels.previous]: icons_2.ChevronLeft,
                [stream_store_1.rels.self]: icons_2.Refresh,
                [stream_store_1.rels.next]: icons_2.ChevronRight,
                [stream_store_1.rels.last]: icons_2.LastPage,
                [stream_store_1.rels.feed]: icons_2.RssFeed,
                [stream_store_1.rels.append]: icons_2.Publish,
                [stream_store_1.rels.metadata]: icons_2.Settings,
                [stream_store_1.rels.deleteStream]: icons_2.DeleteForever,
                [stream_store_1.rels.deleteMessage]: icons_2.DeleteForever,
                [stream_store_1.rels.find]: icons_2.Search,
                [stream_store_1.rels.browse]: icons_2.List,
                [stream_store_1.rels.curies]: icons_2.Help,
            };
            RelIcon = (_a) => {
                var { rel } = _a, props = __rest(_a, ["rel"]);
                return react_20.createElement(fontIconByRel[rel] || icons_2.SqlStreamStore, props);
            };
            exports_46("default", RelIcon);
        }
    };
});
System.register("components/HyperMediaControls/HelpButton", ["@material-ui/core", "components/AuthorizationProvider", "icons/index", "react", "react-remarkable", "uri-template", "utils/index"], function (exports_47, context_47) {
    "use strict";
    var core_7, AuthorizationProvider_1, icons_3, react_21, react_remarkable_2, uri_template_2, utils_11, getCurie, Documentation, HelpButton;
    var __moduleName = context_47 && context_47.id;
    return {
        setters: [
            function (core_7_1) {
                core_7 = core_7_1;
            },
            function (AuthorizationProvider_1_1) {
                AuthorizationProvider_1 = AuthorizationProvider_1_1;
            },
            function (icons_3_1) {
                icons_3 = icons_3_1;
            },
            function (react_21_1) {
                react_21 = react_21_1;
            },
            function (react_remarkable_2_1) {
                react_remarkable_2 = react_remarkable_2_1;
            },
            function (uri_template_2_1) {
                uri_template_2 = uri_template_2_1;
            },
            function (utils_11_1) {
                utils_11 = utils_11_1;
            }
        ],
        execute: function () {
            getCurie = (rel, curies) => {
                const [prefix, rest] = rel.split(':', 2);
                return !rest || rest.indexOf(':') !== -1
                    ? { href: rel, rel }
                    : curies
                        .filter(({ name }) => name === prefix)
                        .map((_a) => {
                        var { href } = _a, link = __rest(_a, ["href"]);
                        return (Object.assign({}, link, { href: uri_template_2.default
                                .parse(decodeURI(href))
                                .expand({ rel: rest }) }));
                    })[0] || { href: rel, rel };
            };
            Documentation = core_7.withStyles(theme => ({
                drawerPaper: {
                    padding: theme.spacing.unit * 2,
                    width: '45%',
                },
            }))(({ open, children, onClose, classes, }) => (react_21.default.createElement(core_7.Drawer, { open: open, onClose: onClose, anchor: 'right', classes: {
                    paper: classes.drawerPaper,
                } },
                react_21.default.createElement(core_7.Typography, null,
                    react_21.default.createElement(react_remarkable_2.default, { options: {
                            typographer: true,
                        } }, children)))));
            HelpButton = class HelpButton extends react_21.PureComponent {
                constructor() {
                    super(...arguments);
                    this.state = {
                        disabled: true,
                        documentation: '',
                        href: '',
                        open: false,
                        type: '',
                    };
                    this._handleOnClick = () => __awaiter(this, void 0, void 0, function* () {
                        const { authorization } = this.props;
                        const { href, type } = this.state;
                        const { body: documentation } = yield utils_11.http.get({
                            headers: { authorization },
                            link: { href, type },
                        });
                        this.setState(Object.assign({}, this.state, { documentation: typeof documentation === 'string'
                                ? documentation
                                : JSON.stringify(documentation), open: true }));
                    });
                    this._handleOnClose = () => this.setState({ open: false });
                }
                render() {
                    const { disabled } = this.props;
                    const { documentation, open } = this.state;
                    return (react_21.default.createElement(core_7.Button, { color: 'secondary', disabled: disabled, onClick: this._handleOnClick },
                        react_21.default.createElement(Documentation, { onClose: this._handleOnClose, open: open }, documentation),
                        react_21.default.createElement(icons_3.Help, null),
                        'Help'));
                }
            };
            HelpButton.getDerivedStateFromProps = ({ rel, curies }, state) => (Object.assign({}, state, { disabled: false }, getCurie(rel, curies)));
            exports_47("default", AuthorizationProvider_1.withAuthorization()(HelpButton));
        }
    };
});
System.register("components/HyperMediaControls/RelButton", ["@material-ui/core", "components/RelIcon", "react"], function (exports_48, context_48) {
    "use strict";
    var core_8, RelIcon_1, react_22, RelButton;
    var __moduleName = context_48 && context_48.id;
    return {
        setters: [
            function (core_8_1) {
                core_8 = core_8_1;
            },
            function (RelIcon_1_1) {
                RelIcon_1 = RelIcon_1_1;
            },
            function (react_22_1) {
                react_22 = react_22_1;
            }
        ],
        execute: function () {
            RelButton = (_a) => {
                var { rel, onClick, title } = _a, props = __rest(_a, ["rel", "onClick", "title"]);
                return (react_22.default.createElement(core_8.Button, Object.assign({ variant: 'text', onClick: onClick }, props),
                    react_22.default.createElement(RelIcon_1.default, { rel: rel, color: 'action' }),
                    title || rel));
            };
            exports_48("default", RelButton);
        }
    };
});
System.register("components/HyperMediaControls/Dialog", ["@material-ui/core", "components/RelIcon", "react", "components/HyperMediaControls/HelpButton", "components/HyperMediaControls/RelButton"], function (exports_49, context_49) {
    "use strict";
    var core_9, RelIcon_2, react_23, HelpButton_1, RelButton_1, styles, SlideUp, isStandardRel;
    var __moduleName = context_49 && context_49.id;
    return {
        setters: [
            function (core_9_1) {
                core_9 = core_9_1;
            },
            function (RelIcon_2_1) {
                RelIcon_2 = RelIcon_2_1;
            },
            function (react_23_1) {
                react_23 = react_23_1;
            },
            function (HelpButton_1_1) {
                HelpButton_1 = HelpButton_1_1;
            },
            function (RelButton_1_1) {
                RelButton_1 = RelButton_1_1;
            }
        ],
        execute: function () {
            styles = (theme) => ({
                button: {
                    margin: theme.spacing.unit,
                },
            });
            SlideUp = props => (react_23.default.createElement(core_9.Slide, Object.assign({ direction: 'up' }, props)));
            isStandardRel = (rel) => rel.indexOf(':') === -1;
            exports_49("default", core_9.withStyles(styles)(class HyperMediaDialog extends react_23.PureComponent {
                constructor() {
                    super(...arguments);
                    this.state = {
                        open: false,
                    };
                    this._onOpen = () => this.setState({
                        open: true,
                    });
                    this._onClose = () => this.setState({
                        open: false,
                    });
                    this._onSubmit = (e) => {
                        const { onSubmit } = this.props;
                        e.preventDefault();
                        onSubmit();
                        this._onClose();
                    };
                }
                render() {
                    const { rel, title, classes, children, curies } = this.props;
                    const { open } = this.state;
                    return (react_23.default.createElement("span", null,
                        react_23.default.createElement(RelButton_1.default, { onClick: this._onOpen, className: classes.button, rel: rel, title: title }),
                        react_23.default.createElement(core_9.Dialog, { open: open, TransitionComponent: SlideUp, disableBackdropClick: false, fullWidth: true, onEscapeKeyDown: this._onClose },
                            react_23.default.createElement(core_9.DialogTitle, null, title),
                            react_23.default.createElement(core_9.DialogContent, null, children),
                            react_23.default.createElement(core_9.DialogActions, null,
                                !isStandardRel(rel) && (react_23.default.createElement(HelpButton_1.default, { rel: rel, curies: curies })),
                                react_23.default.createElement(core_9.Button, { onClick: this._onClose }, 'Cancel'),
                                react_23.default.createElement(core_9.Button, { variant: 'contained', color: 'primary', onClick: this._onSubmit },
                                    react_23.default.createElement(RelIcon_2.default, { rel: rel, color: 'inherit' }),
                                    'Submit')))));
                }
            }));
        }
    };
});
System.register("components/HyperMediaControls/TextAreaField", ["@material-ui/core", "react", "react-schema-form"], function (exports_50, context_50) {
    "use strict";
    var core_10, react_24, react_schema_form_1, getDisplayValue, TextAreaField;
    var __moduleName = context_50 && context_50.id;
    return {
        setters: [
            function (core_10_1) {
                core_10 = core_10_1;
            },
            function (react_24_1) {
                react_24 = react_24_1;
            },
            function (react_schema_form_1_1) {
                react_schema_form_1 = react_schema_form_1_1;
            }
        ],
        execute: function () {
            getDisplayValue = (value) => typeof value === 'string' ? value : JSON.stringify(value);
            TextAreaField = class TextAreaField extends react_24.default.PureComponent {
                constructor(props) {
                    super(props);
                    this._onChangeValidate = (e, v) => {
                        const { form, onChangeValidate } = this.props;
                        const tryParseJson = (value) => {
                            if (!value) {
                                return undefined;
                            }
                            try {
                                return JSON.parse(value);
                            }
                            catch (e) {
                                return value;
                            }
                        };
                        onChangeValidate(Object.assign({}, e, { currentTarget: Object.assign({}, e.currentTarget, { 
                                // @ts-ignore
                                value: form.schema.type === 'object'
                                    ? tryParseJson(e.target.value)
                                    : e.target.value }), target: {
                                // @ts-ignore
                                value: form.schema.type === 'object'
                                    ? tryParseJson(e.target.value)
                                    : e.target.value,
                            } }), v);
                    };
                }
                render() {
                    const { form, error, value } = this.props;
                    return (react_24.default.createElement("div", { className: form.htmlClass },
                        react_24.default.createElement(core_10.TextField, { type: form.type, label: form.title, placeholder: form.placeholder, helperText: error || form.description, error: !!error, onChange: this._onChangeValidate, value: getDisplayValue(value), disabled: form.readonly, fullWidth: true, multiline: true, rows: 15, rowsMax: 15 })));
                }
            };
            exports_50("default", react_schema_form_1.ComposedComponent(TextAreaField));
        }
    };
});
System.register("components/HyperMediaControls/UuidField", ["@material-ui/core", "icons/index", "react", "react-schema-form", "uuid"], function (exports_51, context_51) {
    "use strict";
    var core_11, icons_4, react_25, react_schema_form_2, uuid_1, UuidField;
    var __moduleName = context_51 && context_51.id;
    return {
        setters: [
            function (core_11_1) {
                core_11 = core_11_1;
            },
            function (icons_4_1) {
                icons_4 = icons_4_1;
            },
            function (react_25_1) {
                react_25 = react_25_1;
            },
            function (react_schema_form_2_1) {
                react_schema_form_2 = react_schema_form_2_1;
            },
            function (uuid_1_1) {
                uuid_1 = uuid_1_1;
            }
        ],
        execute: function () {
            UuidField = class UuidField extends react_25.default.PureComponent {
                constructor(props) {
                    super(props);
                    this._onNewUuidClick = () => {
                        const { form, onChange } = this.props;
                        onChange(form.key, uuid_1.default.v4());
                    };
                    const { model, form, setDefault } = this.props;
                    const { key } = form;
                    setDefault(key, model, form, uuid_1.default.v4());
                }
                render() {
                    const { form, error, onChangeValidate, value } = this.props;
                    return (react_25.default.createElement("div", { className: form.htmlClass },
                        react_25.default.createElement(core_11.TextField, { type: form.type, label: form.title, placeholder: form.placeholder, helperText: error || form.description, error: !!error, onChange: onChangeValidate, value: value || '', disabled: form.readonly, fullWidth: true }),
                        react_25.default.createElement(core_11.Button, { color: 'primary', variant: 'contained', onClick: this._onNewUuidClick },
                            "New UUID",
                            react_25.default.createElement(icons_4.SpaceBar, null))));
                }
            };
            exports_51("default", react_schema_form_2.ComposedComponent(UuidField));
        }
    };
});
System.register("components/HyperMediaControls/FormButton", ["components/AuthorizationProvider", "react", "react-schema-form", "components/HyperMediaControls/Dialog", "components/HyperMediaControls/TextAreaField", "components/HyperMediaControls/UuidField"], function (exports_52, context_52) {
    "use strict";
    var AuthorizationProvider_2, react_26, react_schema_form_3, Dialog_1, TextAreaField_1, UuidField_1, mapper, FormButton;
    var __moduleName = context_52 && context_52.id;
    return {
        setters: [
            function (AuthorizationProvider_2_1) {
                AuthorizationProvider_2 = AuthorizationProvider_2_1;
            },
            function (react_26_1) {
                react_26 = react_26_1;
            },
            function (react_schema_form_3_1) {
                react_schema_form_3 = react_schema_form_3_1;
            },
            function (Dialog_1_1) {
                Dialog_1 = Dialog_1_1;
            },
            function (TextAreaField_1_1) {
                TextAreaField_1 = TextAreaField_1_1;
            },
            function (UuidField_1_1) {
                UuidField_1 = UuidField_1_1;
            }
        ],
        execute: function () {
            mapper = {
                textarea: TextAreaField_1.default,
                uuid: UuidField_1.default,
            };
            FormButton = class FormButton extends react_26.PureComponent {
                constructor() {
                    super(...arguments);
                    this.state = {
                        model: {},
                    };
                    this._onSubmit = () => {
                        const { rel, link, actions, authorization } = this.props;
                        const { model: body } = this.state;
                        if (actions[rel]) {
                            actions[rel].request.next({
                                body,
                                headers: {
                                    authorization,
                                },
                                link,
                            });
                        }
                    };
                    this._onModelChange = (key, value) => {
                        const _a = this.state, { model } = _a, state = __rest(_a, ["model"]);
                        this.setState(Object.assign({}, state, { model: Object.assign({}, model, { [key]: value }) }));
                    };
                }
                render() {
                    const { schema, rel, curies } = this.props;
                    const { model } = this.state;
                    return (react_26.default.createElement(Dialog_1.default, { rel: rel, title: schema.title, curies: curies, onSubmit: this._onSubmit },
                        react_26.default.createElement(react_schema_form_3.SchemaForm, { schema: schema, model: model, mapper: mapper, onModelChange: this._onModelChange })));
                }
            };
            exports_52("default", AuthorizationProvider_2.withAuthorization()(FormButton));
        }
    };
});
System.register("components/HyperMediaControls/LinkButton", ["@material-ui/core", "components/NavigationProvider", "react", "uri-template", "utils/index", "components/HyperMediaControls/Dialog", "components/HyperMediaControls/RelButton"], function (exports_53, context_53) {
    "use strict";
    var core_12, NavigationProvider_2, react_27, uri_template_3, utils_12, Dialog_2, RelButton_2, TemplatedLinkButton, NonTemplatedLinkButton;
    var __moduleName = context_53 && context_53.id;
    return {
        setters: [
            function (core_12_1) {
                core_12 = core_12_1;
            },
            function (NavigationProvider_2_1) {
                NavigationProvider_2 = NavigationProvider_2_1;
            },
            function (react_27_1) {
                react_27 = react_27_1;
            },
            function (uri_template_3_1) {
                uri_template_3 = uri_template_3_1;
            },
            function (utils_12_1) {
                utils_12 = utils_12_1;
            },
            function (Dialog_2_1) {
                Dialog_2 = Dialog_2_1;
            },
            function (RelButton_2_1) {
                RelButton_2 = RelButton_2_1;
            }
        ],
        execute: function () {
            TemplatedLinkButton = NavigationProvider_2.withNavigation()(class extends react_27.PureComponent {
                constructor() {
                    super(...arguments);
                    this.state = {};
                    this._onChange = (variable) => ({ currentTarget }) => this.setState(Object.assign({}, this.state, { [variable]: currentTarget.value }));
                }
                render() {
                    const { rel, link, authorization, onNavigate, curies } = this.props;
                    const template = uri_template_3.default.parse(decodeURI(link.href));
                    return (react_27.default.createElement(Dialog_2.default, { rel: rel, title: link.title, curies: curies, onSubmit: () => onNavigate(Object.assign({}, link, { href: template.expand(this.state) }), authorization) }, template.expressions
                        .flatMap(({ params }) => params)
                        .map(({ name }) => (react_27.default.createElement(core_12.TextField, { key: name, label: name, onChange: this._onChange(name), fullWidth: true })))));
                }
            });
            NonTemplatedLinkButton = NavigationProvider_2.withNavigation()(({ link, rel, authorization, onNavigate, }) => (react_27.default.createElement(RelButton_2.default, { rel: rel, title: link.title, onClick: utils_12.preventDefault(() => onNavigate(link, authorization)) })));
            exports_53("default", (_a) => {
                var { link } = _a, props = __rest(_a, ["link"]);
                return link.templated === true ? (react_27.default.createElement(TemplatedLinkButton, Object.assign({ link: link }, props))) : (react_27.default.createElement(NonTemplatedLinkButton, Object.assign({ link: link }, props)));
            });
        }
    };
});
System.register("components/HyperMediaControls/index", ["@material-ui/core", "react", "reactive/index", "rxjs", "stream-store/index", "components/HyperMediaControls/FormButton", "components/HyperMediaControls/LinkButton"], function (exports_54, context_54) {
    "use strict";
    var core_13, react_28, reactive_11, rxjs_12, stream_store_2, FormButton_1, LinkButton_1, isNotSelf, state$, HyperMediaControls;
    var __moduleName = context_54 && context_54.id;
    return {
        setters: [
            function (core_13_1) {
                core_13 = core_13_1;
            },
            function (react_28_1) {
                react_28 = react_28_1;
            },
            function (reactive_11_1) {
                reactive_11 = reactive_11_1;
            },
            function (rxjs_12_1) {
                rxjs_12 = rxjs_12_1;
            },
            function (stream_store_2_1) {
                stream_store_2 = stream_store_2_1;
            },
            function (FormButton_1_1) {
                FormButton_1 = FormButton_1_1;
            },
            function (LinkButton_1_1) {
                LinkButton_1 = LinkButton_1_1;
            }
        ],
        execute: function () {
            isNotSelf = (rel, links) => links[stream_store_2.rels.self] && links[rel][0].href !== links[stream_store_2.rels.self][0].href;
            state$ = reactive_11.createState(stream_store_2.store.hal$.url$.map(href => ['href', () => href]), rxjs_12.Observable.of({ href: '' }));
            HyperMediaControls = ({ actions, forms, href, _links }) => (react_28.default.createElement(core_13.Card, null,
                react_28.default.createElement(core_13.CardActions, null,
                    react_28.default.createElement("div", null,
                        Object.keys(_links)
                            .filter(rel => !stream_store_2.navigation.has(rel))
                            .filter(rel => isNotSelf(rel, _links))
                            .map(rel => (react_28.default.createElement(LinkButton_1.default, { key: rel, rel: rel, link: _links[rel][0], color: 'primary', curies: _links[stream_store_2.rels.curies] }))),
                        Object.keys(forms).map(rel => (react_28.default.createElement(FormButton_1.default, { key: rel, rel: rel, link: { href }, actions: actions, schema: forms[rel], curies: _links[stream_store_2.rels.curies] })))))));
            exports_54("default", reactive_11.connect(state$)(HyperMediaControls));
        }
    };
});
System.register("components/Loading", ["@material-ui/core", "react"], function (exports_55, context_55) {
    "use strict";
    var core_14, react_29, Loading;
    var __moduleName = context_55 && context_55.id;
    return {
        setters: [
            function (core_14_1) {
                core_14 = core_14_1;
            },
            function (react_29_1) {
                react_29 = react_29_1;
            }
        ],
        execute: function () {
            Loading = ({ open }) => (react_29.default.createElement("div", null,
                react_29.default.createElement(core_14.LinearProgress, { variant: open ? 'indeterminate' : 'determinate', value: open ? undefined : 0 }),
                react_29.default.createElement(core_14.Modal, { disableBackdropClick: true, disableEscapeKeyDown: true, open: open },
                    react_29.default.createElement("span", null))));
            exports_55("default", Loading);
        }
    };
});
System.register("components/NavigationLinks", ["@material-ui/core", "react", "stream-store/index", "components/NavigationProvider", "components/RelIcon"], function (exports_56, context_56) {
    "use strict";
    var core_15, react_30, stream_store_3, NavigationProvider_3, RelIcon_3, FeedNavigationLink, NavigationLinks;
    var __moduleName = context_56 && context_56.id;
    return {
        setters: [
            function (core_15_1) {
                core_15 = core_15_1;
            },
            function (react_30_1) {
                react_30 = react_30_1;
            },
            function (stream_store_3_1) {
                stream_store_3 = stream_store_3_1;
            },
            function (NavigationProvider_3_1) {
                NavigationProvider_3 = NavigationProvider_3_1;
            },
            function (RelIcon_3_1) {
                RelIcon_3 = RelIcon_3_1;
            }
        ],
        execute: function () {
            FeedNavigationLink = NavigationProvider_3.withNavigation()(class extends react_30.PureComponent {
                constructor() {
                    super(...arguments);
                    this._handleOnClick = e => {
                        const { onNavigate, authorization, link } = this.props;
                        e.preventDefault();
                        if (!link) {
                            return;
                        }
                        return onNavigate(link, authorization);
                    };
                }
                render() {
                    const { rel, link } = this.props;
                    return (react_30.default.createElement(core_15.IconButton, { disabled: !link, onClick: this._handleOnClick },
                        react_30.default.createElement(RelIcon_3.default, { rel: rel })));
                }
            });
            NavigationLinks = ({ _links, }) => (react_30.default.createElement("nav", null, [...stream_store_3.navigation].map(rel => (react_30.default.createElement(FeedNavigationLink, { key: rel, link: (_links[rel] || [])[0], rel: rel })))));
            exports_56("default", NavigationLinks);
        }
    };
});
System.register("components/Notifications", ["@material-ui/core", "@material-ui/core/colors", "classnames", "icons/index", "react", "reactive/index", "rxjs", "stream-store/index", "uuid"], function (exports_57, context_57) {
    "use strict";
    var core_16, colors_1, classnames_1, icons_5, react_31, reactive_12, rxjs_13, stream_store_4, uuid_2, iconsByVariant, formatTitle, formatSubheader, formatContent, verbs, responses$, clientError$, serverError$, unsafe, success$, dismiss, notification$, state$, styles, Notification, Notifications;
    var __moduleName = context_57 && context_57.id;
    return {
        setters: [
            function (core_16_1) {
                core_16 = core_16_1;
            },
            function (colors_1_1) {
                colors_1 = colors_1_1;
            },
            function (classnames_1_1) {
                classnames_1 = classnames_1_1;
            },
            function (icons_5_1) {
                icons_5 = icons_5_1;
            },
            function (react_31_1) {
                react_31 = react_31_1;
            },
            function (reactive_12_1) {
                reactive_12 = reactive_12_1;
            },
            function (rxjs_13_1) {
                rxjs_13 = rxjs_13_1;
            },
            function (stream_store_4_1) {
                stream_store_4 = stream_store_4_1;
            },
            function (uuid_2_1) {
                uuid_2 = uuid_2_1;
            }
        ],
        execute: function () {
            iconsByVariant = {
                error: icons_5.Error,
                info: icons_5.Info,
                success: icons_5.CheckCircle,
                warning: icons_5.Warning,
            };
            formatTitle = ({ status, statusText, }) => `${status} ${statusText}`;
            formatSubheader = ({ title, type }) => title ? `${title} (${type})` : undefined;
            formatContent = ({ detail }) => !!detail
                ? detail
                    .split(/\r|\n/)
                    .filter(x => x.length)
                    .reduce((akk, line, index) => [
                    ...akk,
                    react_31.default.createElement("br", { key: index * 2 }),
                    react_31.default.createElement("span", { key: index * 2 + 1 }, line),
                ], [])
                : [];
            verbs = Object.keys(stream_store_4.actions);
            responses$ = rxjs_13.Observable.merge(...verbs.map(verb => stream_store_4.actions[verb].response));
            clientError$ = responses$
                .filter(({ status }) => status >= 400 && status < 500)
                .map((_a) => {
                var { body } = _a, response = __rest(_a, ["body"]);
                return ({
                    content: formatContent(body),
                    subheader: formatSubheader(body),
                    title: formatTitle(response),
                    variant: 'warning',
                });
            });
            serverError$ = responses$
                .filter(({ status }) => status >= 500)
                .map((_a) => {
                var { body } = _a, response = __rest(_a, ["body"]);
                return ({
                    content: formatContent(body),
                    subheader: formatSubheader(body),
                    title: formatTitle(response),
                    variant: 'error',
                });
            });
            unsafe = verbs
                .filter(verb => verb !== 'get')
                .map(verb => stream_store_4.actions[verb].response);
            success$ = rxjs_13.Observable
                .merge(...unsafe)
                .filter(({ status }) => status < 400)
                .map((response) => ({
                autoHideDuration: 2000,
                title: formatTitle(response),
                variant: 'success',
            }));
            dismiss = reactive_12.createAction();
            notification$ = rxjs_13.Observable
                .merge(clientError$, serverError$, success$)
                .map(notification => (Object.assign({}, notification, { messageId: uuid_2.default.v4() })));
            state$ = reactive_12.createState(rxjs_13.Observable.merge(notification$.map((notification) => [
                'notifications',
                (notifications) => [
                    ...notifications,
                    notification,
                ],
            ]), dismiss.map(messageId => [
                'notifications',
                (notifications) => notifications.filter(n => n.messageId !== messageId),
            ])), rxjs_13.Observable.of({
                notifications: [],
            }));
            styles = (theme) => ({
                error: {
                    backgroundColor: colors_1.red[500],
                },
                icon: {
                    fontSize: 20,
                },
                iconVariant: {
                    marginRight: theme.spacing.unit,
                    opacity: 0.9,
                },
                info: {
                    backgroundColor: colors_1.blue[500],
                },
                message: {
                    alignItems: 'center',
                    display: 'flex',
                },
                success: {
                    backgroundColor: colors_1.green[600],
                },
                warning: {
                    backgroundColor: colors_1.amber[700],
                },
            });
            Notification = core_16.withStyles(styles)((_a) => {
                var { autoHideDuration, className, classes, content, messageId, subheader, title, variant } = _a, other = __rest(_a, ["autoHideDuration", "className", "classes", "content", "messageId", "subheader", "title", "variant"]);
                return (react_31.default.createElement(core_16.Snackbar, { open: true, anchorOrigin: {
                        horizontal: 'right',
                        vertical: 'bottom',
                    }, autoHideDuration: autoHideDuration },
                    react_31.default.createElement(core_16.SnackbarContent, Object.assign({ className: classnames_1.default(classes[variant], className), message: react_31.default.createElement("span", { className: classes.message },
                            react_31.default.createElement(core_16.Typography, { variant: 'body2' },
                                react_31.createElement(iconsByVariant[variant], {
                                    className: classnames_1.default(classes.icon, classes.iconVariant),
                                }),
                                title,
                                " ",
                                subheader,
                                react_31.default.createElement("br", null),
                                content)), action: [
                            react_31.default.createElement(core_16.IconButton, { key: 'close', color: 'inherit', onClick: () => dismiss.next(messageId) },
                                react_31.default.createElement(core_16.Typography, { variant: 'body2' },
                                    react_31.default.createElement(icons_5.Close, { className: classes.icon }))),
                        ] }, other))));
            });
            Notifications = ({ notifications = [], }) => (react_31.default.createElement("div", null, notifications.map(notification => (react_31.default.createElement(Notification, Object.assign({ key: notification.messageId }, notification))))));
            exports_57("default", reactive_12.connect(state$)(Notifications));
        }
    };
});
System.register("components/StreamBrowser", ["@material-ui/core", "react", "stream-store/index", "components/Hyperlink"], function (exports_58, context_58) {
    "use strict";
    var core_17, react_32, stream_store_5, Hyperlink_1, styles, StreamBrowser;
    var __moduleName = context_58 && context_58.id;
    return {
        setters: [
            function (core_17_1) {
                core_17 = core_17_1;
            },
            function (react_32_1) {
                react_32 = react_32_1;
            },
            function (stream_store_5_1) {
                stream_store_5 = stream_store_5_1;
            },
            function (Hyperlink_1_1) {
                Hyperlink_1 = Hyperlink_1_1;
            }
        ],
        execute: function () {
            styles = (theme) => ({
                browser: {
                    padding: theme.spacing.unit * 2.5,
                },
            });
            StreamBrowser = core_17.withStyles(styles)(({ streams, classes, loading, }) => (react_32.default.createElement("div", { className: classes.browser },
                react_32.default.createElement(core_17.Typography, { variant: 'title' }, "Stream Browser"),
                loading ? (react_32.default.createElement(core_17.LinearProgress, null)) : streams.length ? (react_32.default.createElement(core_17.List, null, streams.map(({ _links }) => (react_32.default.createElement(core_17.ListItem, { key: _links[stream_store_5.rels.self].map(({ href }) => href)[0] },
                    react_32.default.createElement(core_17.ListItemText, null,
                        react_32.default.createElement(Hyperlink_1.default, { _links: _links, rel: stream_store_5.rels.feed }))))))) : (react_32.default.createElement(core_17.Typography, { variant: 'body2' }, "No matching streams found.")))));
            exports_58("default", StreamBrowser);
        }
    };
});
System.register("components/StripeyTable/index", ["@material-ui/core", "react"], function (exports_59, context_59) {
    "use strict";
    var core_18, react_33, TableCell, tableRowStyles, TableRow, StripeyTable;
    var __moduleName = context_59 && context_59.id;
    return {
        setters: [
            function (core_18_1) {
                core_18 = core_18_1;
            },
            function (react_33_1) {
                react_33 = react_33_1;
            }
        ],
        execute: function () {
            TableCell = core_18.withStyles(theme => ({
                head: {
                    backgroundColor: theme.palette.primary.dark,
                    color: theme.palette.common.white,
                },
            }))(core_18.TableCell);
            tableRowStyles = (theme) => ({
                row: {
                    '&:nth-of-type(odd)': {
                        backgroundColor: theme.palette.background.paper,
                    },
                },
            });
            TableRow = core_18.withStyles(tableRowStyles)((_a) => {
                var { classes } = _a, props = __rest(_a, ["classes"]);
                return (react_33.default.createElement(core_18.TableRow, Object.assign({}, props, { className: classes.row })));
            });
            StripeyTable = class StripeyTable extends react_33.PureComponent {
                render() {
                    return react_33.default.createElement(core_18.Table, Object.assign({}, this.props));
                }
            };
            StripeyTable.Body = core_18.TableBody;
            StripeyTable.Row = TableRow;
            StripeyTable.Cell = TableCell;
            StripeyTable.Head = core_18.TableHead;
            StripeyTable.Footer = core_18.TableFooter;
            exports_59("default", StripeyTable);
        }
    };
});
System.register("components/index", ["components/AuthorizationProvider", "components/NavigationProvider", "components/Hyperlink", "components/HyperMediaControls/index", "components/Loading", "components/NavigationLinks", "components/Notifications", "components/StreamBrowser", "components/StripeyTable/index"], function (exports_60, context_60) {
    "use strict";
    var AuthorizationProvider_3, NavigationProvider_4;
    var __moduleName = context_60 && context_60.id;
    return {
        setters: [
            function (AuthorizationProvider_3_1) {
                AuthorizationProvider_3 = AuthorizationProvider_3_1;
            },
            function (NavigationProvider_4_1) {
                NavigationProvider_4 = NavigationProvider_4_1;
            },
            function (Hyperlink_2_1) {
                exports_60({
                    "Hyperlink": Hyperlink_2_1["default"]
                });
            },
            function (HyperMediaControls_1_1) {
                exports_60({
                    "HyperMediaControls": HyperMediaControls_1_1["default"]
                });
            },
            function (Loading_1_1) {
                exports_60({
                    "Loading": Loading_1_1["default"]
                });
            },
            function (NavigationLinks_1_1) {
                exports_60({
                    "NavigationLinks": NavigationLinks_1_1["default"]
                });
            },
            function (Notifications_1_1) {
                exports_60({
                    "Notifications": Notifications_1_1["default"]
                });
            },
            function (StreamBrowser_2_1) {
                exports_60({
                    "StreamBrowser": StreamBrowser_2_1["default"]
                });
            },
            function (StripeyTable_1_1) {
                exports_60({
                    "Table": StripeyTable_1_1["default"]
                });
            }
        ],
        execute: function () {
            exports_60("AuthorizationProvider", AuthorizationProvider_3.default);
            exports_60("withAuthorization", AuthorizationProvider_3.withAuthorization);
            exports_60("NavigationProvider", NavigationProvider_4.default);
            exports_60("withNavigation", NavigationProvider_4.withNavigation);
        }
    };
});
System.register("SqlStreamStoreBrowser", ["@material-ui/core", "@material-ui/core/styles", "components/index", "icons/index", "react", "reactive/index", "rxjs", "stream-store/index", "themes", "utils/index", "components/getDisplayName"], function (exports_61, context_61) {
    "use strict";
    var core_19, styles_1, index_1, icons_6, react_34, reactive_13, rxjs_14, stream_store_6, themes_3, utils_13, getDisplayName_3, getSelfAlias, self$, state$, onNavigate, initialNavigation, mount, lightbulbs, heroStyle, onThemeToggle, Hero, SqlStreamStoreBrowser, AuthorizedSqlStreamStoreBrowser;
    var __moduleName = context_61 && context_61.id;
    return {
        setters: [
            function (core_19_1) {
                core_19 = core_19_1;
            },
            function (styles_1_1) {
                styles_1 = styles_1_1;
            },
            function (index_1_1) {
                index_1 = index_1_1;
            },
            function (icons_6_1) {
                icons_6 = icons_6_1;
            },
            function (react_34_1) {
                react_34 = react_34_1;
            },
            function (reactive_13_1) {
                reactive_13 = reactive_13_1;
            },
            function (rxjs_14_1) {
                rxjs_14 = rxjs_14_1;
            },
            function (stream_store_6_1) {
                stream_store_6 = stream_store_6_1;
            },
            function (themes_3_1) {
                themes_3 = themes_3_1;
            },
            function (utils_13_1) {
                utils_13 = utils_13_1;
            },
            function (getDisplayName_3_1) {
                getDisplayName_3 = getDisplayName_3_1;
            }
        ],
        execute: function () {
            getSelfAlias = (links) => Object.keys(links)
                .flatMap(rel => links[rel])
                .filter(({ rel }) => rel && rel.indexOf('streamStore:') === 0)
                .filter(({ href }) => !!links.self.filter(link => link.href === href).length)
                .map(({ rel }) => rel);
            self$ = stream_store_6.store.hal$.links$
                .filter(links => !!links.self)
                .map(getSelfAlias)
                .filter(rel => !!rel)
                .map(([link]) => link);
            state$ = reactive_13.createState(rxjs_14.Observable.merge(self$.map(self => ['self', () => self]), stream_store_6.store.hal$.links$.map(links => ['_links', () => links]), stream_store_6.store.hal$.forms$.map(forms => ['forms', () => forms]), stream_store_6.store.hal$.loading$.map(loading => ['loading', () => loading]), stream_store_6.store.mediaType$.map(mediaType => ['mediaType', () => mediaType]), themes_3.default.theme$.map(theme => ['theme', () => theme])), rxjs_14.Observable.of({
                _links: {},
                forms: {},
                loading: false,
                mediaType: utils_13.mediaTypes.hal,
                self: {
                    href: '',
                },
                theme: themes_3.default.defaultTheme,
            }));
            onNavigate = (link, authorization) => link.href.indexOf('#') === -1 &&
                stream_store_6.actions.get.request.next({ link, headers: { authorization } });
            initialNavigation = ({ authorization }) => onNavigate({ href: window.location.href, type: utils_13.mediaTypes.any }, authorization);
            mount = (didMount, willUnmount) => (WrappedComponent) => {
                class Mount extends react_34.PureComponent {
                    componentDidMount() {
                        didMount(this.props);
                    }
                    componentWillUnmount() {
                        if (!willUnmount) {
                            return;
                        }
                        willUnmount(this.props);
                    }
                    render() {
                        return react_34.default.createElement(WrappedComponent, this.props);
                    }
                }
                Mount.displayName = getDisplayName_3.default('Mount', WrappedComponent);
                return Mount;
            };
            lightbulbs = {
                dark: icons_6.LightbulbFull,
                light: icons_6.LightbulbOutline,
            };
            heroStyle = {
                themeToggle: {
                    marginLeft: 'auto',
                },
            };
            onThemeToggle = utils_13.preventDefault(() => themes_3.default.actions.type.next(void 0));
            Hero = core_19.withStyles(heroStyle)(({ theme, classes }) => (react_34.default.createElement(core_19.AppBar, { position: 'static' },
                react_34.default.createElement(core_19.Toolbar, null,
                    react_34.default.createElement(icons_6.SqlStreamStore, { color: 'action' }),
                    react_34.default.createElement(core_19.Typography, { variant: 'h6', color: 'inherit' }, "Sql Stream Store"),
                    react_34.default.createElement(core_19.IconButton, { onClick: onThemeToggle, className: classes.themeToggle }, react_34.createElement(lightbulbs[theme.palette.type]))))));
            SqlStreamStoreBrowser = index_1.withAuthorization()(mount(initialNavigation)((_a) => {
                var { loading, theme } = _a, props = __rest(_a, ["loading", "theme"]);
                return (react_34.default.createElement(styles_1.MuiThemeProvider, { theme: theme },
                    react_34.default.createElement("div", null,
                        react_34.default.createElement(core_19.CssBaseline, null),
                        react_34.default.createElement(Hero, { theme: theme }),
                        react_34.default.createElement(index_1.Loading, { open: loading }),
                        react_34.default.createElement(index_1.NavigationProvider, { onNavigate: onNavigate },
                            react_34.default.createElement(stream_store_6.Viewer, Object.assign({}, props)),
                            react_34.default.createElement(index_1.Notifications, null)))));
            }));
            exports_61("AuthorizedSqlStreamStoreBrowser", AuthorizedSqlStreamStoreBrowser = (_a) => {
                var { authorization } = _a, props = __rest(_a, ["authorization"]);
                return (react_34.default.createElement(index_1.AuthorizationProvider, { authorization: authorization },
                    react_34.default.createElement(SqlStreamStoreBrowser, Object.assign({}, props))));
            });
            exports_61("default", reactive_13.connect(state$)(AuthorizedSqlStreamStoreBrowser));
        }
    };
});
System.register("TestBrowser", ["react"], function (exports_62, context_62) {
    "use strict";
    var react_35, TestBrowser;
    var __moduleName = context_62 && context_62.id;
    return {
        setters: [
            function (react_35_1) {
                react_35 = react_35_1;
            }
        ],
        execute: function () {
            TestBrowser = class TestBrowser extends react_35.PureComponent {
                render() {
                    return (react_35.default.createElement("div", null, "Test"));
                }
            };
            exports_62("default", TestBrowser);
            ;
        }
    };
});
System.register("index", ["array.prototype.flatmap", "react", "react-dom", "SqlStreamStoreBrowser", "TestBrowser"], function (exports_63, context_63) {
    "use strict";
    var array_prototype_flatmap_1, react_36, react_dom_1, SqlStreamStoreBrowser_1, TestBrowser_1;
    var __moduleName = context_63 && context_63.id;
    return {
        setters: [
            function (array_prototype_flatmap_1_1) {
                array_prototype_flatmap_1 = array_prototype_flatmap_1_1;
            },
            function (react_36_1) {
                react_36 = react_36_1;
            },
            function (react_dom_1_1) {
                react_dom_1 = react_dom_1_1;
            },
            function (SqlStreamStoreBrowser_1_1) {
                SqlStreamStoreBrowser_1 = SqlStreamStoreBrowser_1_1;
            },
            function (TestBrowser_1_1) {
                TestBrowser_1 = TestBrowser_1_1;
            }
        ],
        execute: function () {
            array_prototype_flatmap_1.default.shim();
            window.SqlStreamStoreBrowser = SqlStreamStoreBrowser_1.default;
            window.TestBrowser = TestBrowser_1.default;
            window.ReactDOM = react_dom_1.default;
            window.React = react_36.default;
            exports_63("default", TestBrowser_1.default);
        }
    };
});
System.register("stream-store/store/hal/streamBrowser", ["reactive/index", "rxjs", "stream-store/rels", "uri-template", "stream-store/store/hal/links"], function (exports_64, context_64) {
    "use strict";
    var reactive_14, rxjs_15, rels_10, uri_template_4, links_2, isPotentialStreamId, clickPotentialStreamId, pattern$, template$;
    var __moduleName = context_64 && context_64.id;
    return {
        setters: [
            function (reactive_14_1) {
                reactive_14 = reactive_14_1;
            },
            function (rxjs_15_1) {
                rxjs_15 = rxjs_15_1;
            },
            function (rels_10_1) {
                rels_10 = rels_10_1;
            },
            function (uri_template_4_1) {
                uri_template_4 = uri_template_4_1;
            },
            function (links_2_1) {
                links_2 = links_2_1;
            }
        ],
        execute: function () {
            isPotentialStreamId = (data) => typeof data === 'number' || typeof data === 'string';
            clickPotentialStreamId = reactive_14.createAction().filter(isPotentialStreamId);
            pattern$ = rxjs_15.Observable.merge(clickPotentialStreamId.map(pattern => pattern), clickPotentialStreamId.map(pattern => String(pattern).replace(/-/g, ''))).distinct();
            template$ = links_2.default
                .filter(links => !!links[rels_10.default.browse])
                .map(links => links[rels_10.default.browse][0])
                .map(link => uri_template_4.default.parse(decodeURI(link.href)));
            pattern$.combineLatest(template$, (p, template) => ({
                headers: { authorization: '' },
                link: {
                    href: template.expand({ p, t: 'e' }),
                },
            }));
        }
    };
});
